/*! AdminLTE app.js
 * ================
 * Main JS application file for AdminLTE v2. This file
 * should be included in all pages. It controls some layout
 * options and implements exclusive AdminLTE plugins.
 *
 * @Author  Almsaeed Studio
 * @Support <http://www.almsaeedstudio.com>
 * @Email   <abdullah@almsaeedstudio.com>
 * @version 2.3.8
 * @license MIT <http://opensource.org/licenses/MIT>
 */
function _init(){"use strict";$.AdminLTE.layout={activate:function(){var e=this;e.fix(),e.fixSidebar(),$("body, html, .wrapper").css("height","auto"),$(window,".wrapper").resize(function(){e.fix(),e.fixSidebar()})},fix:function(){$(".layout-boxed > .wrapper").css("overflow","hidden");var e=$(".main-footer").outerHeight()||0,t=$(".main-header").outerHeight()+e,n=$(window).height(),r=$(".sidebar").height()||0;if($("body").hasClass("fixed"))$(".content-wrapper, .right-side").css("min-height",n-e);else{var o;n>=r?($(".content-wrapper, .right-side").css("min-height",n-t),o=n-t):($(".content-wrapper, .right-side").css("min-height",r),o=r);var i=$($.AdminLTE.options.controlSidebarOptions.selector);"undefined"!=typeof i&&i.height()>o&&$(".content-wrapper, .right-side").css("min-height",i.height())}},fixSidebar:function(){return $("body").hasClass("fixed")?("undefined"==typeof $.fn.slimScroll&&window.console&&window.console.error("Error: the fixed layout requires the slimscroll plugin!"),void($.AdminLTE.options.sidebarSlimScroll&&"undefined"!=typeof $.fn.slimScroll&&($(".sidebar").slimScroll({destroy:!0}).height("auto"),$(".sidebar").slimScroll({height:$(window).height()-$(".main-header").height()+"px",color:"rgba(0,0,0,0.2)",size:"3px"})))):void("undefined"!=typeof $.fn.slimScroll&&$(".sidebar").slimScroll({destroy:!0}).height("auto"))}},$.AdminLTE.pushMenu={activate:function(e){var t=$.AdminLTE.options.screenSizes;$(document).on("click",e,function(e){e.preventDefault(),$(window).width()>t.sm-1?$("body").hasClass("sidebar-collapse")?$("body").removeClass("sidebar-collapse").trigger("expanded.pushMenu"):$("body").addClass("sidebar-collapse").trigger("collapsed.pushMenu"):$("body").hasClass("sidebar-open")?$("body").removeClass("sidebar-open").removeClass("sidebar-collapse").trigger("collapsed.pushMenu"):$("body").addClass("sidebar-open").trigger("expanded.pushMenu")}),$(".content-wrapper").click(function(){$(window).width()<=t.sm-1&&$("body").hasClass("sidebar-open")&&$("body").removeClass("sidebar-open")}),($.AdminLTE.options.sidebarExpandOnHover||$("body").hasClass("fixed")&&$("body").hasClass("sidebar-mini"))&&this.expandOnHover()},expandOnHover:function(){var e=this,t=$.AdminLTE.options.screenSizes.sm-1;$(".main-sidebar").hover(function(){$("body").hasClass("sidebar-mini")&&$("body").hasClass("sidebar-collapse")&&$(window).width()>t&&e.expand()},function(){$("body").hasClass("sidebar-mini")&&$("body").hasClass("sidebar-expanded-on-hover")&&$(window).width()>t&&e.collapse()})},expand:function(){$("body").removeClass("sidebar-collapse").addClass("sidebar-expanded-on-hover")},collapse:function(){$("body").hasClass("sidebar-expanded-on-hover")&&$("body").removeClass("sidebar-expanded-on-hover").addClass("sidebar-collapse")}},$.AdminLTE.tree=function(e){var t=this,n=$.AdminLTE.options.animationSpeed;$(document).off("click",e+" li a").on("click",e+" li a",function(e){var r=$(this),o=r.next();if(o.is(".treeview-menu")&&o.is(":visible")&&!$("body").hasClass("sidebar-collapse"))o.slideUp(n,function(){o.removeClass("menu-open")}),o.parent("li").removeClass("active");else if(o.is(".treeview-menu")&&!o.is(":visible")){var i=r.parents("ul").first(),a=i.find("ul:visible").slideUp(n);a.removeClass("menu-open");var s=r.parent("li");o.slideDown(n,function(){o.addClass("menu-open"),i.find("li.active").removeClass("active"),s.addClass("active"),t.layout.fix()})}o.is(".treeview-menu")&&e.preventDefault()})},$.AdminLTE.controlSidebar={activate:function(){var e=this,t=$.AdminLTE.options.controlSidebarOptions,n=$(t.selector),r=$(t.toggleBtnSelector);r.on("click",function(r){r.preventDefault(),n.hasClass("control-sidebar-open")||$("body").hasClass("control-sidebar-open")?e.close(n,t.slide):e.open(n,t.slide)});var o=$(".control-sidebar-bg");e._fix(o),$("body").hasClass("fixed")?e._fixForFixed(n):$(".content-wrapper, .right-side").height()<n.height()&&e._fixForContent(n)},open:function(e,t){t?e.addClass("control-sidebar-open"):$("body").addClass("control-sidebar-open")},close:function(e,t){t?e.removeClass("control-sidebar-open"):$("body").removeClass("control-sidebar-open")},_fix:function(e){var t=this;if($("body").hasClass("layout-boxed")){if(e.css("position","absolute"),e.height($(".wrapper").height()),t.hasBindedResize)return;$(window).resize(function(){t._fix(e)}),t.hasBindedResize=!0}else e.css({position:"fixed",height:"auto"})},_fixForFixed:function(e){e.css({position:"fixed","max-height":"100%",overflow:"auto","padding-bottom":"50px"})},_fixForContent:function(e){$(".content-wrapper, .right-side").css("min-height",e.height())}},$.AdminLTE.boxWidget={selectors:$.AdminLTE.options.boxWidgetOptions.boxWidgetSelectors,icons:$.AdminLTE.options.boxWidgetOptions.boxWidgetIcons,animationSpeed:$.AdminLTE.options.animationSpeed,activate:function(e){var t=this;e||(e=document),$(e).on("click",t.selectors.collapse,function(e){e.preventDefault(),t.collapse($(this))}),$(e).on("click",t.selectors.remove,function(e){e.preventDefault(),t.remove($(this))})},collapse:function(e){var t=this,n=e.parents(".box").first(),r=n.find("> .box-body, > .box-footer, > form  >.box-body, > form > .box-footer");n.hasClass("collapsed-box")?(e.children(":first").removeClass(t.icons.open).addClass(t.icons.collapse),r.slideDown(t.animationSpeed,function(){n.removeClass("collapsed-box")})):(e.children(":first").removeClass(t.icons.collapse).addClass(t.icons.open),r.slideUp(t.animationSpeed,function(){n.addClass("collapsed-box")}))},remove:function(e){var t=e.parents(".box").first();t.slideUp(this.animationSpeed)}}}function $notificationProvider(){function e(e,n,r){function o(n,r){function i(){r=angular.extend({focusWindowOnClick:!0},t.options||{},r);try{a.baseNotification=new e.Notification(n,r)}catch(e){return}r.delay&&setTimeout(angular.bind(a,a.close),r.delay),r.focusWindowOnClick&&a.$on("click",function(){e.focus()}),a._events.forEach(function(e){a.$on.apply(a,e)}),a._events=[]}if(!e.Notification)return!1;r=r||{};var a=this;return this._events=[],"granted"===e.Notification.permission?i():void("denied"!==e.Notification.permission&&o.requestPermission().then(i))}function i(e,t){return new o(e,t)}return o.prototype.$on=function(e,t){function r(){var e=arguments;n.$apply(function(){t.apply(o,e)})}var o=this;return this.baseNotification?(this.baseNotification.addEventListener(e,r),function(){this.baseNotification.removeListener(event,r)}):this._events.push([e,t])},o.prototype.close=function(){this.baseNotification&&this.baseNotification.close()},o.isSupported=!!e.Notification,o.getPermission=function(){return e.Notification?e.Notification.permission:void 0},o.requestPermission=function(){return r(function(t,n){return e.Notification?void e.Notification.requestPermission(function(n){e.Notification.permission=e.Notification.permission||n,t(e.Notification.permission)}):n()})},i.isSupported=o.isSupported,i.getPermission=o.getPermission,i.requestPermission=o.requestPermission,i}var t=this;this.$get=["$window","$rootScope","$q",e],this.setOptions=function(e){this.options=e}}if("undefined"==typeof jQuery)throw new Error("AdminLTE requires jQuery");$.AdminLTE={},$.AdminLTE.options={navbarMenuSlimscroll:!0,navbarMenuSlimscrollWidth:"3px",navbarMenuHeight:"200px",animationSpeed:500,sidebarToggleSelector:"[data-toggle='offcanvas']",sidebarPushMenu:!0,sidebarSlimScroll:!0,sidebarExpandOnHover:!1,enableBoxRefresh:!0,enableBSToppltip:!0,BSTooltipSelector:"[data-toggle='tooltip']",enableFastclick:!1,enableControlTreeView:!0,enableControlSidebar:!0,controlSidebarOptions:{toggleBtnSelector:"[data-toggle='control-sidebar']",selector:".control-sidebar",slide:!0},enableBoxWidget:!0,boxWidgetOptions:{boxWidgetIcons:{collapse:"fa-minus",open:"fa-plus",remove:"fa-times"},boxWidgetSelectors:{remove:'[data-widget="remove"]',collapse:'[data-widget="collapse"]'}},directChat:{enable:!0,contactToggleSelector:'[data-widget="chat-pane-toggle"]'},colors:{lightBlue:"#3c8dbc",red:"#f56954",green:"#00a65a",aqua:"#00c0ef",yellow:"#f39c12",blue:"#0073b7",navy:"#001F3F",teal:"#39CCCC",olive:"#3D9970",lime:"#01FF70",orange:"#FF851B",fuchsia:"#F012BE",purple:"#8E24AA",maroon:"#D81B60",black:"#222222",gray:"#d2d6de"},screenSizes:{xs:480,sm:768,md:992,lg:1200}},$(function(){"use strict";$("body").removeClass("hold-transition"),"undefined"!=typeof AdminLTEOptions&&$.extend(!0,$.AdminLTE.options,AdminLTEOptions);var e=$.AdminLTE.options;_init(),$.AdminLTE.layout.activate(),e.enableControlTreeView&&$.AdminLTE.tree(".sidebar"),e.enableControlSidebar&&$.AdminLTE.controlSidebar.activate(),e.navbarMenuSlimscroll&&"undefined"!=typeof $.fn.slimscroll&&$(".navbar .menu").slimscroll({height:e.navbarMenuHeight,alwaysVisible:!1,size:e.navbarMenuSlimscrollWidth}).css("width","100%"),e.sidebarPushMenu&&$.AdminLTE.pushMenu.activate(e.sidebarToggleSelector),e.enableBSToppltip&&$("body").tooltip({selector:e.BSTooltipSelector,container:"body"}),e.enableBoxWidget&&$.AdminLTE.boxWidget.activate(),e.enableFastclick&&"undefined"!=typeof FastClick&&FastClick.attach(document.body),e.directChat.enable&&$(document).on("click",e.directChat.contactToggleSelector,function(){var e=$(this).parents(".direct-chat").first();e.toggleClass("direct-chat-contacts-open")}),$('.btn-group[data-toggle="btn-toggle"]').each(function(){var e=$(this);$(this).find(".btn").on("click",function(t){e.find(".btn.active").removeClass("active"),$(this).addClass("active"),t.preventDefault()})})}),function(e){"use strict";e.fn.boxRefresh=function(t){function n(e){e.append(i),o.onLoadStart.call(e)}function r(e){e.find(i).remove(),o.onLoadDone.call(e)}var o=e.extend({trigger:".refresh-btn",source:"",onLoadStart:function(e){return e},onLoadDone:function(e){return e}},t),i=e('<div class="overlay"><div class="fa fa-refresh fa-spin"></div></div>');return this.each(function(){if(""===o.source)return void(window.console&&window.console.log("Please specify a source first - boxRefresh()"));var t=e(this),i=t.find(o.trigger).first();i.on("click",function(e){e.preventDefault(),n(t),t.find(".box-body").load(o.source,function(){r(t)})})})}}(jQuery),function(e){"use strict";e.fn.activateBox=function(){e.AdminLTE.boxWidget.activate(this)},e.fn.toggleBox=function(){var t=e(e.AdminLTE.boxWidget.selectors.collapse,this);e.AdminLTE.boxWidget.collapse(t)},e.fn.removeBox=function(){var t=e(e.AdminLTE.boxWidget.selectors.remove,this);e.AdminLTE.boxWidget.remove(t)}}(jQuery),function(e){"use strict";e.fn.todolist=function(t){var n=e.extend({onCheck:function(e){return e},onUncheck:function(e){return e}},t);return this.each(function(){"undefined"!=typeof e.fn.iCheck?(e("input",this).on("ifChecked",function(){var t=e(this).parents("li").first();t.toggleClass("done"),n.onCheck.call(t)}),e("input",this).on("ifUnchecked",function(){var t=e(this).parents("li").first();t.toggleClass("done"),n.onUncheck.call(t)})):e("input",this).on("change",function(){var t=e(this).parents("li").first();t.toggleClass("done"),e("input",t).is(":checked")?n.onCheck.call(t):n.onUncheck.call(t)})})}}(jQuery),/*! Copyright (c) 2011 Piotr Rochala (http://rocha.la)
 * Dual licensed under the MIT (http://www.opensource.org/licenses/mit-license.php)
 * and GPL (http://www.opensource.org/licenses/gpl-license.php) licenses.
 *
 * Version: 1.3.8
 *
 */
function(e){e.fn.extend({slimScroll:function(n){var r=e.extend({width:"auto",height:"250px",size:"7px",color:"#000",position:"right",distance:"1px",start:"top",opacity:.4,alwaysVisible:!1,disableFadeOut:!1,railVisible:!1,railColor:"#333",railOpacity:.2,railDraggable:!0,railClass:"slimScrollRail",barClass:"slimScrollBar",wrapperClass:"slimScrollDiv",allowPageScroll:!1,wheelStep:20,touchScrollStep:200,borderRadius:"7px",railBorderRadius:"7px"},n);return this.each(function(){function o(t){if(u){t=t||window.event;var n=0;t.wheelDelta&&(n=-t.wheelDelta/120),t.detail&&(n=t.detail/3),e(t.target||t.srcTarget||t.srcElement).closest("."+r.wrapperClass).is(y.parent())&&i(n,!0),t.preventDefault&&!v&&t.preventDefault(),v||(t.returnValue=!1)}}function i(e,t,n){v=!1;var o=y.outerHeight()-C.outerHeight();t&&(t=parseInt(C.css("top"))+e*parseInt(r.wheelStep)/100*C.outerHeight(),t=Math.min(Math.max(t,0),o),t=0<e?Math.ceil(t):Math.floor(t),C.css({top:t+"px"})),g=parseInt(C.css("top"))/(y.outerHeight()-C.outerHeight()),t=g*(y[0].scrollHeight-y.outerHeight()),n&&(t=e,e=t/y[0].scrollHeight*y.outerHeight(),e=Math.min(Math.max(e,0),o),C.css({top:e+"px"})),y.scrollTop(t),y.trigger("slimscrolling",~~t),s(),l()}function a(){h=Math.max(y.outerHeight()/y[0].scrollHeight*y.outerHeight(),30),C.css({height:h+"px"});var e=h==y.outerHeight()?"none":"block";C.css({display:e})}function s(){a(),clearTimeout(f),g==~~g?(v=r.allowPageScroll,m!=g&&y.trigger("slimscroll",0==~~g?"top":"bottom")):v=!1,m=g,h>=y.outerHeight()?v=!0:(C.stop(!0,!0).fadeIn("fast"),r.railVisible&&w.stop(!0,!0).fadeIn("fast"))}function l(){r.alwaysVisible||(f=setTimeout(function(){r.disableFadeOut&&u||c||d||(C.fadeOut("slow"),w.fadeOut("slow"))},1e3))}var u,c,d,f,p,h,g,m,v=!1,y=e(this);if(y.parent().hasClass(r.wrapperClass)){var b=y.scrollTop(),C=y.siblings("."+r.barClass),w=y.siblings("."+r.railClass);if(a(),e.isPlainObject(n)){if("height"in n&&"auto"==n.height){y.parent().css("height","auto"),y.css("height","auto");var S=y.parent().parent().height();y.parent().css("height",S),y.css("height",S)}else"height"in n&&(S=n.height,y.parent().css("height",S),y.css("height",S));if("scrollTo"in n)b=parseInt(r.scrollTo);else if("scrollBy"in n)b+=parseInt(r.scrollBy);else if("destroy"in n)return C.remove(),w.remove(),void y.unwrap();i(b,!1,!0)}}else if(!(e.isPlainObject(n)&&"destroy"in n)){r.height="auto"==r.height?y.parent().height():r.height,b=e("<div></div>").addClass(r.wrapperClass).css({position:"relative",overflow:"hidden",width:r.width,height:r.height}),y.css({overflow:"hidden",width:r.width,height:r.height});var w=e("<div></div>").addClass(r.railClass).css({width:r.size,height:"100%",position:"absolute",top:0,display:r.alwaysVisible&&r.railVisible?"block":"none","border-radius":r.railBorderRadius,background:r.railColor,opacity:r.railOpacity,zIndex:90}),C=e("<div></div>").addClass(r.barClass).css({background:r.color,width:r.size,position:"absolute",top:0,opacity:r.opacity,display:r.alwaysVisible?"block":"none","border-radius":r.borderRadius,BorderRadius:r.borderRadius,MozBorderRadius:r.borderRadius,WebkitBorderRadius:r.borderRadius,zIndex:99}),S="right"==r.position?{right:r.distance}:{left:r.distance};w.css(S),C.css(S),y.wrap(b),y.parent().append(C),y.parent().append(w),r.railDraggable&&C.bind("mousedown",function(n){var r=e(document);return d=!0,t=parseFloat(C.css("top")),pageY=n.pageY,r.bind("mousemove.slimscroll",function(e){currTop=t+e.pageY-pageY,C.css("top",currTop),i(0,C.position().top,!1)}),r.bind("mouseup.slimscroll",function(e){d=!1,l(),r.unbind(".slimscroll")}),!1}).bind("selectstart.slimscroll",function(e){return e.stopPropagation(),e.preventDefault(),!1}),w.hover(function(){s()},function(){l()}),C.hover(function(){c=!0},function(){c=!1}),y.hover(function(){u=!0,s(),l()},function(){u=!1,l()}),y.bind("touchstart",function(e,t){e.originalEvent.touches.length&&(p=e.originalEvent.touches[0].pageY)}),y.bind("touchmove",function(e){v||e.originalEvent.preventDefault(),e.originalEvent.touches.length&&(i((p-e.originalEvent.touches[0].pageY)/r.touchScrollStep,!0),p=e.originalEvent.touches[0].pageY)}),a(),"bottom"===r.start?(C.css({top:y.outerHeight()-C.outerHeight()}),i(0,!0)):"top"!==r.start&&(i(e(r.start).position().top,null,!0),r.alwaysVisible||C.hide()),window.addEventListener?(this.addEventListener("DOMMouseScroll",o,!1),this.addEventListener("mousewheel",o,!1)):document.attachEvent("onmousewheel",o)}}),this}}),e.fn.extend({slimscroll:e.fn.slimScroll})}(jQuery),!function(e,t,n){"use strict";!function e(t,n,r){function o(a,s){if(!n[a]){if(!t[a]){var l="function"==typeof require&&require;if(!s&&l)return l(a,!0);if(i)return i(a,!0);var u=new Error("Cannot find module '"+a+"'");throw u.code="MODULE_NOT_FOUND",u}var c=n[a]={exports:{}};t[a][0].call(c.exports,function(e){var n=t[a][1][e];return o(n?n:e)},c,c.exports,e,t,n,r)}return n[a].exports}for(var i="function"==typeof require&&require,a=0;a<r.length;a++)o(r[a]);return o}({1:[function(r,o,i){var a=function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(i,"__esModule",{value:!0});var s,l,u,c,d=r("./modules/handle-dom"),f=r("./modules/utils"),p=r("./modules/handle-swal-dom"),h=r("./modules/handle-click"),g=r("./modules/handle-key"),m=a(g),v=r("./modules/default-params"),y=a(v),b=r("./modules/set-params"),C=a(b);i.default=u=c=function(){function r(e){var t=o;return t[e]===n?y.default[e]:t[e]}var o=arguments[0];if(d.addClass(t.body,"stop-scrolling"),p.resetInput(),o===n)return f.logStr("SweetAlert expects at least 1 attribute!"),!1;var i=f.extend({},y.default);switch(typeof o){case"string":i.title=o,i.text=arguments[1]||"",i.type=arguments[2]||"";break;case"object":if(o.title===n)return f.logStr('Missing "title" argument!'),!1;i.title=o.title;for(var a in y.default)i[a]=r(a);i.confirmButtonText=i.showCancelButton?"Confirm":y.default.confirmButtonText,i.confirmButtonText=r("confirmButtonText"),i.doneFunction=arguments[1]||null;break;default:return f.logStr('Unexpected type of argument! Expected "string" or "object", got '+typeof o),!1}C.default(i),p.fixVerticalPosition(),p.openModal(arguments[1]);for(var u=p.getModal(),g=u.querySelectorAll("button"),v=["onclick","onmouseover","onmouseout","onmousedown","onmouseup","onfocus"],b=function(e){return h.handleButton(e,i,u)},w=0;w<g.length;w++)for(var S=0;S<v.length;S++){var $=v[S];g[w][$]=b}p.getOverlay().onclick=b,s=e.onkeydown;var T=function(e){return m.default(e,i,u)};e.onkeydown=T,e.onfocus=function(){setTimeout(function(){l!==n&&(l.focus(),l=n)},0)},c.enableButtons()},u.setDefaults=c.setDefaults=function(e){if(!e)throw new Error("userParams is required");if("object"!=typeof e)throw new Error("userParams has to be a object");f.extend(y.default,e)},u.close=c.close=function(){var r=p.getModal();d.fadeOut(p.getOverlay(),5),d.fadeOut(r,5),d.removeClass(r,"showSweetAlert"),d.addClass(r,"hideSweetAlert"),d.removeClass(r,"visible");var o=r.querySelector(".sa-icon.sa-success");d.removeClass(o,"animate"),d.removeClass(o.querySelector(".sa-tip"),"animateSuccessTip"),d.removeClass(o.querySelector(".sa-long"),"animateSuccessLong");var i=r.querySelector(".sa-icon.sa-error");d.removeClass(i,"animateErrorIcon"),d.removeClass(i.querySelector(".sa-x-mark"),"animateXMark");var a=r.querySelector(".sa-icon.sa-warning");return d.removeClass(a,"pulseWarning"),d.removeClass(a.querySelector(".sa-body"),"pulseWarningIns"),d.removeClass(a.querySelector(".sa-dot"),"pulseWarningIns"),setTimeout(function(){var e=r.getAttribute("data-custom-class");d.removeClass(r,e)},300),d.removeClass(t.body,"stop-scrolling"),e.onkeydown=s,e.previousActiveElement&&e.previousActiveElement.focus(),l=n,clearTimeout(r.timeout),!0},u.showInputError=c.showInputError=function(e){var t=p.getModal(),n=t.querySelector(".sa-input-error");d.addClass(n,"show");var r=t.querySelector(".sa-error-container");d.addClass(r,"show"),r.querySelector("p").innerHTML=e,setTimeout(function(){u.enableButtons()},1),t.querySelector("input").focus()},u.resetInputError=c.resetInputError=function(e){if(e&&13===e.keyCode)return!1;var t=p.getModal(),n=t.querySelector(".sa-input-error");d.removeClass(n,"show");var r=t.querySelector(".sa-error-container");d.removeClass(r,"show")},u.disableButtons=c.disableButtons=function(){var e=p.getModal(),t=e.querySelector("button.confirm"),n=e.querySelector("button.cancel");t.disabled=!0,n.disabled=!0},u.enableButtons=c.enableButtons=function(){var e=p.getModal(),t=e.querySelector("button.confirm"),n=e.querySelector("button.cancel");t.disabled=!1,n.disabled=!1},"undefined"!=typeof e?e.sweetAlert=e.swal=u:f.logStr("SweetAlert is a frontend module!"),o.exports=i.default},{"./modules/default-params":2,"./modules/handle-click":3,"./modules/handle-dom":4,"./modules/handle-key":5,"./modules/handle-swal-dom":6,"./modules/set-params":8,"./modules/utils":9}],2:[function(e,t,n){Object.defineProperty(n,"__esModule",{value:!0});var r={title:"",text:"",type:null,allowOutsideClick:!1,showConfirmButton:!0,showCancelButton:!1,closeOnConfirm:!0,closeOnCancel:!0,confirmButtonText:"OK",confirmButtonColor:"#8CD4F5",cancelButtonText:"Cancel",imageUrl:null,imageSize:null,timer:null,customClass:"",html:!1,animation:!0,allowEscapeKey:!0,inputType:"text",inputPlaceholder:"",inputValue:"",showLoaderOnConfirm:!1};n.default=r,t.exports=n.default},{}],3:[function(t,n,r){Object.defineProperty(r,"__esModule",{value:!0});var o=t("./utils"),i=(t("./handle-swal-dom"),t("./handle-dom")),a=function(t,n,r){function a(e){h&&n.confirmButtonColor&&(p.style.backgroundColor=e)}var u,c,d,f=t||e.event,p=f.target||f.srcElement,h=-1!==p.className.indexOf("confirm"),g=-1!==p.className.indexOf("sweet-overlay"),m=i.hasClass(r,"visible"),v=n.doneFunction&&"true"===r.getAttribute("data-has-done-function");switch(h&&n.confirmButtonColor&&(u=n.confirmButtonColor,c=o.colorLuminance(u,-.04),d=o.colorLuminance(u,-.14)),f.type){case"mouseover":a(c);break;case"mouseout":a(u);break;case"mousedown":a(d);break;case"mouseup":a(c);break;case"focus":var y=r.querySelector("button.confirm"),b=r.querySelector("button.cancel");h?b.style.boxShadow="none":y.style.boxShadow="none";break;case"click":var C=r===p,w=i.isDescendant(r,p);if(!C&&!w&&m&&!n.allowOutsideClick)break;h&&v&&m?s(r,n):v&&m||g?l(r,n):i.isDescendant(r,p)&&"BUTTON"===p.tagName&&sweetAlert.close()}},s=function(e,t){var n=!0;i.hasClass(e,"show-input")&&(n=e.querySelector("input").value,n||(n="")),t.doneFunction(n),t.closeOnConfirm&&sweetAlert.close(),t.showLoaderOnConfirm&&sweetAlert.disableButtons()},l=function(e,t){var n=String(t.doneFunction).replace(/\s/g,""),r="function("===n.substring(0,9)&&")"!==n.substring(9,10);r&&t.doneFunction(!1),t.closeOnCancel&&sweetAlert.close()};r.default={handleButton:a,handleConfirm:s,handleCancel:l},n.exports=r.default},{"./handle-dom":4,"./handle-swal-dom":6,"./utils":9}],4:[function(n,r,o){Object.defineProperty(o,"__esModule",{value:!0});var i=function(e,t){return new RegExp(" "+t+" ").test(" "+e.className+" ")},a=function(e,t){i(e,t)||(e.className+=" "+t)},s=function(e,t){var n=" "+e.className.replace(/[\t\r\n]/g," ")+" ";if(i(e,t)){for(;n.indexOf(" "+t+" ")>=0;)n=n.replace(" "+t+" "," ");e.className=n.replace(/^\s+|\s+$/g,"")}},l=function(e){var n=t.createElement("div");return n.appendChild(t.createTextNode(e)),n.innerHTML},u=function(e){e.style.opacity="",e.style.display="block"},c=function(e){if(e&&!e.length)return u(e);for(var t=0;t<e.length;++t)u(e[t])},d=function(e){e.style.opacity="",e.style.display="none"},f=function(e){if(e&&!e.length)return d(e);for(var t=0;t<e.length;++t)d(e[t])},p=function(e,t){for(var n=t.parentNode;null!==n;){if(n===e)return!0;n=n.parentNode}return!1},h=function(e){e.style.left="-9999px",e.style.display="block";var t,n=e.clientHeight;return t="undefined"!=typeof getComputedStyle?parseInt(getComputedStyle(e).getPropertyValue("padding-top"),10):parseInt(e.currentStyle.padding),e.style.left="",e.style.display="none","-"+parseInt((n+t)/2)+"px"},g=function(e,t){if(+e.style.opacity<1){t=t||16,e.style.opacity=0,e.style.display="block";var n=+new Date,r=function(e){function t(){return e.apply(this,arguments)}return t.toString=function(){return e.toString()},t}(function(){e.style.opacity=+e.style.opacity+(new Date-n)/100,n=+new Date,+e.style.opacity<1&&setTimeout(r,t)});r()}e.style.display="block"},m=function(e,t){t=t||16,e.style.opacity=1;var n=+new Date,r=function(e){function t(){return e.apply(this,arguments)}return t.toString=function(){return e.toString()},t}(function(){e.style.opacity=+e.style.opacity-(new Date-n)/100,n=+new Date,+e.style.opacity>0?setTimeout(r,t):e.style.display="none"});r()},v=function(n){if("function"==typeof MouseEvent){var r=new MouseEvent("click",{view:e,bubbles:!1,cancelable:!0});n.dispatchEvent(r)}else if(t.createEvent){var o=t.createEvent("MouseEvents");o.initEvent("click",!1,!1),n.dispatchEvent(o)}else t.createEventObject?n.fireEvent("onclick"):"function"==typeof n.onclick&&n.onclick()},y=function(t){"function"==typeof t.stopPropagation?(t.stopPropagation(),t.preventDefault()):e.event&&e.event.hasOwnProperty("cancelBubble")&&(e.event.cancelBubble=!0)};o.hasClass=i,o.addClass=a,o.removeClass=s,o.escapeHtml=l,o._show=u,o.show=c,o._hide=d,o.hide=f,o.isDescendant=p,o.getTopMargin=h,o.fadeIn=g,o.fadeOut=m,o.fireClick=v,o.stopEventPropagation=y},{}],5:[function(t,r,o){Object.defineProperty(o,"__esModule",{value:!0});var i=t("./handle-dom"),a=t("./handle-swal-dom"),s=function(t,r,o){var s=t||e.event,l=s.keyCode||s.which,u=o.querySelector("button.confirm"),c=o.querySelector("button.cancel"),d=o.querySelectorAll("button[tabindex]");if(-1!==[9,13,32,27].indexOf(l)){for(var f=s.target||s.srcElement,p=-1,h=0;h<d.length;h++)if(f===d[h]){p=h;break}9===l?(f=-1===p?u:p===d.length-1?d[0]:d[p+1],i.stopEventPropagation(s),f.focus(),r.confirmButtonColor&&a.setFocusStyle(f,r.confirmButtonColor)):13===l?("INPUT"===f.tagName&&(f=u,u.focus()),f=-1===p?u:n):27===l&&r.allowEscapeKey===!0?(f=c,i.fireClick(f,s)):f=n}};o.default=s,r.exports=o.default},{"./handle-dom":4,"./handle-swal-dom":6}],6:[function(n,r,o){var i=function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(o,"__esModule",{value:!0});var a=n("./utils"),s=n("./handle-dom"),l=n("./default-params"),u=i(l),c=n("./injected-html"),d=i(c),f=".sweet-alert",p=".sweet-overlay",h=function(){var e=t.createElement("div");for(e.innerHTML=d.default;e.firstChild;)t.body.appendChild(e.firstChild)},g=function(e){function t(){return e.apply(this,arguments)}return t.toString=function(){return e.toString()},t}(function(){var e=t.querySelector(f);return e||(h(),e=g()),e}),m=function(){var e=g();return e?e.querySelector("input"):void 0},v=function(){return t.querySelector(p)},y=function(e,t){var n=a.hexToRgb(t);e.style.boxShadow="0 0 2px rgba("+n+", 0.8), inset 0 0 0 1px rgba(0, 0, 0, 0.05)"},b=function(n){var r=g();s.fadeIn(v(),10),s.show(r),s.addClass(r,"showSweetAlert"),s.removeClass(r,"hideSweetAlert"),e.previousActiveElement=t.activeElement;var o=r.querySelector("button.confirm");o.focus(),setTimeout(function(){s.addClass(r,"visible")},500);var i=r.getAttribute("data-timer");if("null"!==i&&""!==i){var a=n;r.timeout=setTimeout(function(){var e=(a||null)&&"true"===r.getAttribute("data-has-done-function");e?a(null):sweetAlert.close()},i)}},C=function(){var e=g(),t=m();s.removeClass(e,"show-input"),t.value=u.default.inputValue,t.setAttribute("type",u.default.inputType),t.setAttribute("placeholder",u.default.inputPlaceholder),w()},w=function(e){if(e&&13===e.keyCode)return!1;var t=g(),n=t.querySelector(".sa-input-error");s.removeClass(n,"show");var r=t.querySelector(".sa-error-container");s.removeClass(r,"show")},S=function(){var e=g();e.style.marginTop=s.getTopMargin(g())};o.sweetAlertInitialize=h,o.getModal=g,o.getOverlay=v,o.getInput=m,o.setFocusStyle=y,o.openModal=b,o.resetInput=C,o.resetInputError=w,o.fixVerticalPosition=S},{"./default-params":2,"./handle-dom":4,"./injected-html":7,"./utils":9}],7:[function(e,t,n){Object.defineProperty(n,"__esModule",{value:!0});var r='<div class="sweet-overlay" tabIndex="-1"></div><div class="sweet-alert"><div class="sa-icon sa-error">\n      <span class="sa-x-mark">\n        <span class="sa-line sa-left"></span>\n        <span class="sa-line sa-right"></span>\n      </span>\n    </div><div class="sa-icon sa-warning">\n      <span class="sa-body"></span>\n      <span class="sa-dot"></span>\n    </div><div class="sa-icon sa-info"></div><div class="sa-icon sa-success">\n      <span class="sa-line sa-tip"></span>\n      <span class="sa-line sa-long"></span>\n\n      <div class="sa-placeholder"></div>\n      <div class="sa-fix"></div>\n    </div><div class="sa-icon sa-custom"></div><h2>Title</h2>\n    <p>Text</p>\n    <fieldset>\n      <input type="text" tabIndex="3" />\n      <div class="sa-input-error"></div>\n    </fieldset><div class="sa-error-container">\n      <div class="icon">!</div>\n      <p>Not valid!</p>\n    </div><div class="sa-button-container">\n      <button class="cancel" tabIndex="2">Cancel</button>\n      <div class="sa-confirm-button-container">\n        <button class="confirm" tabIndex="1">OK</button><div class="la-ball-fall">\n          <div></div>\n          <div></div>\n          <div></div>\n        </div>\n      </div>\n    </div></div>';n.default=r,t.exports=n.default},{}],8:[function(e,t,r){Object.defineProperty(r,"__esModule",{value:!0});var o=e("./utils"),i=e("./handle-swal-dom"),a=e("./handle-dom"),s=["error","warning","info","success","input","prompt"],l=function(e){var t=i.getModal(),r=t.querySelector("h2"),l=t.querySelector("p"),u=t.querySelector("button.cancel"),c=t.querySelector("button.confirm");if(r.innerHTML=e.html?e.title:a.escapeHtml(e.title).split("\n").join("<br>"),l.innerHTML=e.html?e.text:a.escapeHtml(e.text||"").split("\n").join("<br>"),e.text&&a.show(l),e.customClass)a.addClass(t,e.customClass),t.setAttribute("data-custom-class",e.customClass);else{var d=t.getAttribute("data-custom-class");a.removeClass(t,d),t.setAttribute("data-custom-class","")}if(a.hide(t.querySelectorAll(".sa-icon")),e.type&&!o.isIE8()){var f=function(){for(var r=!1,o=0;o<s.length;o++)if(e.type===s[o]){r=!0;break}if(!r)return logStr("Unknown alert type: "+e.type),{v:!1};var l=["success","error","warning","info"],u=n;-1!==l.indexOf(e.type)&&(u=t.querySelector(".sa-icon.sa-"+e.type),a.show(u));var c=i.getInput();switch(e.type){case"success":a.addClass(u,"animate"),a.addClass(u.querySelector(".sa-tip"),"animateSuccessTip"),a.addClass(u.querySelector(".sa-long"),"animateSuccessLong");break;case"error":a.addClass(u,"animateErrorIcon"),a.addClass(u.querySelector(".sa-x-mark"),"animateXMark");break;case"warning":a.addClass(u,"pulseWarning"),a.addClass(u.querySelector(".sa-body"),"pulseWarningIns"),a.addClass(u.querySelector(".sa-dot"),"pulseWarningIns");break;case"input":case"prompt":c.setAttribute("type",e.inputType),c.value=e.inputValue,c.setAttribute("placeholder",e.inputPlaceholder),a.addClass(t,"show-input"),setTimeout(function(){c.focus(),c.addEventListener("keyup",swal.resetInputError)},400)}}();if("object"==typeof f)return f.v}if(e.imageUrl){var p=t.querySelector(".sa-icon.sa-custom");p.style.backgroundImage="url("+e.imageUrl+")",a.show(p);var h=80,g=80;if(e.imageSize){var m=e.imageSize.toString().split("x"),v=m[0],y=m[1];v&&y?(h=v,g=y):logStr("Parameter imageSize expects value with format WIDTHxHEIGHT, got "+e.imageSize)}p.setAttribute("style",p.getAttribute("style")+"width:"+h+"px; height:"+g+"px")}t.setAttribute("data-has-cancel-button",e.showCancelButton),e.showCancelButton?u.style.display="inline-block":a.hide(u),t.setAttribute("data-has-confirm-button",e.showConfirmButton),e.showConfirmButton?c.style.display="inline-block":a.hide(c),e.cancelButtonText&&(u.innerHTML=a.escapeHtml(e.cancelButtonText)),e.confirmButtonText&&(c.innerHTML=a.escapeHtml(e.confirmButtonText)),e.confirmButtonColor&&(c.style.backgroundColor=e.confirmButtonColor,c.style.borderLeftColor=e.confirmLoadingButtonColor,c.style.borderRightColor=e.confirmLoadingButtonColor,i.setFocusStyle(c,e.confirmButtonColor)),t.setAttribute("data-allow-outside-click",e.allowOutsideClick);var b=!!e.doneFunction;t.setAttribute("data-has-done-function",b),e.animation?"string"==typeof e.animation?t.setAttribute("data-animation",e.animation):t.setAttribute("data-animation","pop"):t.setAttribute("data-animation","none"),t.setAttribute("data-timer",e.timer)};r.default=l,t.exports=r.default},{"./handle-dom":4,"./handle-swal-dom":6,"./utils":9}],9:[function(t,n,r){Object.defineProperty(r,"__esModule",{value:!0});var o=function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);return e},i=function(e){var t=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(e);return t?parseInt(t[1],16)+", "+parseInt(t[2],16)+", "+parseInt(t[3],16):null},a=function(){return e.attachEvent&&!e.addEventListener},s=function(t){e.console&&e.console.log("SweetAlert: "+t)},l=function(e,t){e=String(e).replace(/[^0-9a-f]/gi,""),e.length<6&&(e=e[0]+e[0]+e[1]+e[1]+e[2]+e[2]),t=t||0;var n,r,o="#";for(r=0;3>r;r++)n=parseInt(e.substr(2*r,2),16),n=Math.round(Math.min(Math.max(0,n+n*t),255)).toString(16),o+=("00"+n).substr(n.length);return o};r.extend=o,r.hexToRgb=i,r.isIE8=a,r.logStr=s,r.colorLuminance=l},{}]},{},[1]),"function"==typeof define&&define.amd?define(function(){return sweetAlert}):"undefined"!=typeof module&&module.exports&&(module.exports=sweetAlert)}(window,document),/*!
 * angular-translate - v2.14.0 - 2017-02-11
 * 
 * Copyright (c) 2017 The angular-translate team, Pascal Precht; Licensed MIT
 */
!function(e,t){"function"==typeof define&&define.amd?define([],function(){return t()}):"object"==typeof exports?module.exports=t():t()}(this,function(){function e(e){"use strict";var t=e.storageKey(),n=e.storage(),r=function(){var r=e.preferredLanguage();angular.isString(r)?e.use(r):n.put(t,e.use())};r.displayName="fallbackFromIncorrectStorageValue",n?n.get(t)?e.use(n.get(t)).catch(r):r():angular.isString(e.preferredLanguage())&&e.use(e.preferredLanguage())}function t(){"use strict";var e,t,n,r=null,o=!1,i=!1;n={sanitize:function(e,t){return"text"===t&&(e=s(e)),e},escape:function(e,t){return"text"===t&&(e=a(e)),e},sanitizeParameters:function(e,t){return"params"===t&&(e=u(e,s)),e},escapeParameters:function(e,t){return"params"===t&&(e=u(e,a)),e},sce:function(e,t,n){return"text"===t?e=l(e):"params"===t&&"filter"!==n&&(e=u(e,a)),e},sceParameters:function(e,t){return"params"===t&&(e=u(e,l)),e}},n.escaped=n.escapeParameters,this.addStrategy=function(e,t){return n[e]=t,this},this.removeStrategy=function(e){return delete n[e],this},this.useStrategy=function(e){return o=!0,r=e,this},this.$get=["$injector","$log",function(a,s){var l={},u=function(e,t,r,o){return angular.forEach(o,function(o){if(angular.isFunction(o))e=o(e,t,r);else if(angular.isFunction(n[o]))e=n[o](e,t,r);else{if(!angular.isString(n[o]))throw new Error("pascalprecht.translate.$translateSanitization: Unknown sanitization strategy: '"+o+"'");if(!l[n[o]])try{l[n[o]]=a.get(n[o])}catch(e){throw l[n[o]]=function(){},new Error("pascalprecht.translate.$translateSanitization: Unknown sanitization strategy: '"+o+"'")}e=l[n[o]](e,t,r)}}),e},c=function(){o||i||(s.warn("pascalprecht.translate.$translateSanitization: No sanitization strategy has been configured. This can have serious security implications. See http://angular-translate.github.io/docs/#/guide/19_security for details."),i=!0)};return a.has("$sanitize")&&(e=a.get("$sanitize")),a.has("$sce")&&(t=a.get("$sce")),{useStrategy:function(e){return function(t){e.useStrategy(t)}}(this),sanitize:function(e,t,n,o){if(r||c(),n||null===n||(n=r),!n)return e;o||(o="service");var i=angular.isArray(n)?n:[n];return u(e,t,o,i)}}}];var a=function(e){var t=angular.element("<div></div>");return t.text(e),t.html()},s=function(t){if(!e)throw new Error("pascalprecht.translate.$translateSanitization: Error cannot find $sanitize service. Either include the ngSanitize module (https://docs.angularjs.org/api/ngSanitize) or use a sanitization strategy which does not depend on $sanitize, such as 'escape'.");return e(t)},l=function(e){if(!t)throw new Error("pascalprecht.translate.$translateSanitization: Error cannot find $sce service.");return t.trustAsHtml(e)},u=function(e,t,n){if(angular.isDate(e))return e;if(angular.isObject(e)){var r=angular.isArray(e)?[]:{};if(n){if(n.indexOf(e)>-1)throw new Error("pascalprecht.translate.$translateSanitization: Error cannot interpolate parameter due recursive object")}else n=[];return n.push(e),angular.forEach(e,function(e,o){angular.isFunction(e)||(r[o]=u(e,t,n))}),n.splice(-1,1),r}return angular.isNumber(e)?e:angular.isUndefined(e)||null===e?e:t(e)}}function n(e,t,n,r){"use strict";var o,i,a,s,l,u,c,d,f,p,h,g,m,v,y,b,C={},w=[],S=e,$=[],T="translate-cloak",x=!1,E=!1,k=".",A=!1,O=!1,B=0,L=!0,M="default",P={default:function(e){return(e||"").split("-").join("_")},java:function(e){var t=(e||"").split("-").join("_"),n=t.split("_");return n.length>1?n[0].toLowerCase()+"_"+n[1].toUpperCase():t},bcp47:function(e){var t=(e||"").split("_").join("-"),n=t.split("-");return n.length>1?n[0].toLowerCase()+"-"+n[1].toUpperCase():t},"iso639-1":function(e){var t=(e||"").split("_").join("-"),n=t.split("-");return n[0].toLowerCase()}},N="2.14.0",D=function(){if(angular.isFunction(r.getLocale))return r.getLocale();var e,n,o=t.$get().navigator,i=["language","browserLanguage","systemLanguage","userLanguage"];if(angular.isArray(o.languages))for(e=0;e<o.languages.length;e++)if(n=o.languages[e],n&&n.length)return n;for(e=0;e<i.length;e++)if(n=o[i[e]],n&&n.length)return n;return null};D.displayName="angular-translate/service: getFirstBrowserLanguage";var I=function(){var e=D()||"";return P[M]&&(e=P[M](e)),e};I.displayName="angular-translate/service: getLocale";var _=function(e,t){for(var n=0,r=e.length;n<r;n++)if(e[n]===t)return n;return-1},F=function(){return this.toString().replace(/^\s+|\s+$/g,"")},j=function(e){if(e){for(var t=[],n=angular.lowercase(e),r=0,o=w.length;r<o;r++)t.push(angular.lowercase(w[r]));if(_(t,n)>-1)return e;if(i){var a;for(var s in i)if(i.hasOwnProperty(s)){var l=!1,u=Object.prototype.hasOwnProperty.call(i,s)&&angular.lowercase(s)===angular.lowercase(e);if("*"===s.slice(-1)&&(l=s.slice(0,-1)===e.slice(0,s.length-1)),(u||l)&&(a=i[s],_(t,angular.lowercase(a))>-1))return a}}var c=e.split("_");return c.length>1&&_(t,angular.lowercase(c[0]))>-1?c[0]:void 0}},R=function(e,t){if(!e&&!t)return C;if(e&&!t){if(angular.isString(e))return C[e]}else angular.isObject(C[e])||(C[e]={}),angular.extend(C[e],z(t));return this};this.translations=R,this.cloakClassName=function(e){return e?(T=e,this):T},this.nestedObjectDelimeter=function(e){return e?(k=e,this):k};var z=function(e,t,n,r){var o,i,a,s;t||(t=[]),n||(n={});for(o in e)Object.prototype.hasOwnProperty.call(e,o)&&(s=e[o],angular.isObject(s)?z(s,t.concat(o),n,o):(i=t.length?""+t.join(k)+k+o:o,t.length&&o===r&&(a=""+t.join(k),n[a]="@:"+i),n[i]=s));return n};z.displayName="flatObject",this.addInterpolation=function(e){return $.push(e),this},this.useMessageFormatInterpolation=function(){return this.useInterpolation("$translateMessageFormatInterpolation")},this.useInterpolation=function(e){return p=e,this},this.useSanitizeValueStrategy=function(e){return n.useStrategy(e),this},this.preferredLanguage=function(e){return e?(U(e),this):o};var U=function(e){return e&&(o=e),o};this.translationNotFoundIndicator=function(e){return this.translationNotFoundIndicatorLeft(e),this.translationNotFoundIndicatorRight(e),this},this.translationNotFoundIndicatorLeft=function(e){return e?(m=e,this):m},this.translationNotFoundIndicatorRight=function(e){return e?(v=e,this):v},this.fallbackLanguage=function(e){return q(e),this};var q=function(e){return e?(angular.isString(e)?(s=!0,a=[e]):angular.isArray(e)&&(s=!1,a=e),angular.isString(o)&&_(a,o)<0&&a.push(o),this):s?a[0]:a};this.use=function(e){if(e){if(!C[e]&&!h)throw new Error("$translateProvider couldn't find translationTable for langKey: '"+e+"'");return l=e,this}return l},this.resolveClientLocale=function(){return I()};var W=function(e){return e?(S=e,this):d?d+S:S};this.storageKey=W,this.useUrlLoader=function(e,t){return this.useLoader("$translateUrlLoader",angular.extend({url:e},t))},this.useStaticFilesLoader=function(e){return this.useLoader("$translateStaticFilesLoader",e)},this.useLoader=function(e,t){return h=e,g=t||{},this},this.useLocalStorage=function(){return this.useStorage("$translateLocalStorage")},this.useCookieStorage=function(){return this.useStorage("$translateCookieStorage")},this.useStorage=function(e){return c=e,this},this.storagePrefix=function(e){return e?(d=e,this):e},this.useMissingTranslationHandlerLog=function(){return this.useMissingTranslationHandler("$translateMissingTranslationHandlerLog")},this.useMissingTranslationHandler=function(e){return f=e,this},this.usePostCompiling=function(e){return x=!!e,this},this.forceAsyncReload=function(e){return E=!!e,this},this.uniformLanguageTag=function(e){return e?angular.isString(e)&&(e={standard:e}):e={},M=e.standard,this},this.determinePreferredLanguage=function(e){var t=e&&angular.isFunction(e)?e():I();return o=w.length?j(t)||t:t,this},this.registerAvailableLanguageKeys=function(e,t){return e?(w=e,t&&(i=t),this):w},this.useLoaderCache=function(e){return e===!1?y=void 0:e===!0?y=!0:"undefined"==typeof e?y="$translationCache":e&&(y=e),this},this.directivePriority=function(e){return void 0===e?B:(B=e,this)},this.statefulFilter=function(e){return void 0===e?L:(L=e,this)},this.postProcess=function(e){return b=e?e:void 0,this},this.keepContent=function(e){return O=!!e,this},this.$get=["$log","$injector","$rootScope","$q",function(e,t,n,r){var i,d,M,P=t.get(p||"$translateDefaultInterpolation"),D=!1,H={},V={},X=function(e,t,n,s,u){!l&&o&&(l=o);var f=u&&u!==l?j(u)||u:l;if(u&&ce(u),angular.isArray(e)){var p=function(e){for(var o={},i=[],a=function(e){var i=r.defer(),a=function(t){o[e]=t,i.resolve([e,t])};return X(e,t,n,s,u).then(a,a),i.promise},l=0,c=e.length;l<c;l++)i.push(a(e[l]));return r.all(i).then(function(){return o})};return p(e)}var h=r.defer();e&&(e=F.apply(e));var g=function(){var e=o?V[o]:V[f];if(d=0,c&&!e){var t=i.get(S);if(e=V[t],a&&a.length){var n=_(a,t);d=0===n?1:0,_(a,o)<0&&a.push(o)}}return e}();if(g){var m=function(){u||(f=l),ae(e,t,n,s,f).then(h.resolve,h.reject)};m.displayName="promiseResolved",g.finally(m).catch(angular.noop)}else ae(e,t,n,s,f).then(h.resolve,h.reject);return h.promise},G=function(e){return m&&(e=[m,e].join(" ")),v&&(e=[e,v].join(" ")),e},K=function(e){l=e,c&&i.put(X.storageKey(),l),n.$emit("$translateChangeSuccess",{language:e}),P.setLocale(l);var t=function(e,t){H[t].setLocale(l)};t.displayName="eachInterpolatorLocaleSetter",angular.forEach(H,t),n.$emit("$translateChangeEnd",{language:e})},Y=function(e){if(!e)throw"No language key specified for loading.";var o=r.defer();n.$emit("$translateLoadingStart",{language:e}),D=!0;var i=y;"string"==typeof i&&(i=t.get(i));var a=angular.extend({},g,{key:e,$http:angular.extend({},{cache:i},g.$http)}),s=function(t){var r={};n.$emit("$translateLoadingSuccess",{language:e}),angular.isArray(t)?angular.forEach(t,function(e){angular.extend(r,z(e))}):angular.extend(r,z(t)),D=!1,o.resolve({key:e,table:r}),n.$emit("$translateLoadingEnd",{language:e})};s.displayName="onLoaderSuccess";var l=function(e){n.$emit("$translateLoadingError",{language:e}),o.reject(e),n.$emit("$translateLoadingEnd",{language:e})};return l.displayName="onLoaderError",t.get(h)(a).then(s,l),o.promise};if(c&&(i=t.get(c),!i.get||!i.put))throw new Error("Couldn't use storage '"+c+"', missing get() or put() method!");if($.length){var Q=function(e){var n=t.get(e);n.setLocale(o||l),H[n.getInterpolationIdentifier()]=n};Q.displayName="interpolationFactoryAdder",angular.forEach($,Q)}var Z=function(e){var t=r.defer();if(Object.prototype.hasOwnProperty.call(C,e))t.resolve(C[e]);else if(V[e]){var n=function(e){R(e.key,e.table),t.resolve(e.table)};n.displayName="translationTableResolver",V[e].then(n,t.reject)}else t.reject();return t.promise},J=function(e,t,n,o,i){var a=r.defer(),s=function(r){if(Object.prototype.hasOwnProperty.call(r,t)&&null!==r[t]){o.setLocale(e);var s=r[t];if("@:"===s.substr(0,2))J(e,s.substr(2),n,o,i).then(a.resolve,a.reject);else{var u=o.interpolate(r[t],n,"service",i,t);u=ue(t,r[t],u,n,e),a.resolve(u)}o.setLocale(l)}else a.reject()};return s.displayName="fallbackTranslationResolver",Z(e).then(s,a.reject),a.promise},ee=function(e,t,n,r,o){var i,a=C[e];if(a&&Object.prototype.hasOwnProperty.call(a,t)&&null!==a[t]){if(r.setLocale(e),i=r.interpolate(a[t],n,"filter",o,t),i=ue(t,a[t],i,n,e,o),!angular.isString(i)&&angular.isFunction(i.$$unwrapTrustedValue)){var s=i.$$unwrapTrustedValue();if("@:"===s.substr(0,2))return ee(e,s.substr(2),n,r,o)}else if("@:"===i.substr(0,2))return ee(e,i.substr(2),n,r,o);r.setLocale(l)}return i},te=function(e,n,r,o){return f?t.get(f)(e,l,n,r,o):e},ne=function(e,t,n,o,i,s){var l=r.defer();if(e<a.length){var u=a[e];J(u,t,n,o,s).then(function(e){l.resolve(e)},function(){return ne(e+1,t,n,o,i,s).then(l.resolve,l.reject)})}else if(i)l.resolve(i);else{var c=te(t,n,i);f&&c?l.resolve(c):l.reject(G(t))}return l.promise},re=function(e,t,n,r,o){var i;if(e<a.length){var s=a[e];i=ee(s,t,n,r,o),i||""===i||(i=re(e+1,t,n,r))}return i},oe=function(e,t,n,r,o){return ne(M>0?M:d,e,t,n,r,o)},ie=function(e,t,n,r){return re(M>0?M:d,e,t,n,r)},ae=function(e,t,n,o,i,s){var l=r.defer(),u=i?C[i]:C,c=n?H[n]:P;if(u&&Object.prototype.hasOwnProperty.call(u,e)&&null!==u[e]){var d=u[e];if("@:"===d.substr(0,2))X(d.substr(2),t,n,o,i).then(l.resolve,l.reject);else{var p=c.interpolate(d,t,"service",s,e);p=ue(e,d,p,t,i),l.resolve(p)}}else{var h;f&&!D&&(h=te(e,t,o)),i&&a&&a.length?oe(e,t,c,o,s).then(function(e){l.resolve(e)},function(e){l.reject(G(e))}):f&&!D&&h?o?l.resolve(o):l.resolve(h):o?l.resolve(o):l.reject(G(e))}return l.promise},se=function(e,t,n,r,o){var i,s=r?C[r]:C,l=P;if(H&&Object.prototype.hasOwnProperty.call(H,n)&&(l=H[n]),s&&Object.prototype.hasOwnProperty.call(s,e)&&null!==s[e]){var u=s[e];"@:"===u.substr(0,2)?i=se(u.substr(2),t,n,r,o):(i=l.interpolate(u,t,"filter",o,e),i=ue(e,u,i,t,r,o))}else{var c;f&&!D&&(c=te(e,t,o)),r&&a&&a.length?(d=0,i=ie(e,t,l,o)):i=f&&!D&&c?c:G(e)}return i},le=function(e){u===e&&(u=void 0),V[e]=void 0},ue=function(e,n,r,o,i,a){var s=b;return s&&("string"==typeof s&&(s=t.get(s)),s)?s(e,n,r,o,i,a):r},ce=function(e){C[e]||!h||V[e]||(V[e]=Y(e).then(function(e){return R(e.key,e.table),e}))};X.preferredLanguage=function(e){return e&&U(e),o},X.cloakClassName=function(){return T},X.nestedObjectDelimeter=function(){return k},X.fallbackLanguage=function(e){if(void 0!==e&&null!==e){if(q(e),h&&a&&a.length)for(var t=0,n=a.length;t<n;t++)V[a[t]]||(V[a[t]]=Y(a[t]));X.use(X.use())}return s?a[0]:a},X.useFallbackLanguage=function(e){if(void 0!==e&&null!==e)if(e){var t=_(a,e);t>-1&&(M=t)}else M=0},X.proposedLanguage=function(){return u},X.storage=function(){return i},X.negotiateLocale=j,X.use=function(e){if(!e)return l;var t=r.defer();t.promise.then(null,angular.noop),n.$emit("$translateChangeStart",{language:e});var o=j(e);return w.length>0&&!o?r.reject(e):(o&&(e=o),u=e,!E&&C[e]||!h||V[e]?V[e]?V[e].then(function(e){return u===e.key&&K(e.key),t.resolve(e.key),e},function(e){return!l&&a&&a.length>0&&a[0]!==e?X.use(a[0]).then(t.resolve,t.reject):t.reject(e)}):(t.resolve(e),K(e)):(V[e]=Y(e).then(function(n){return R(n.key,n.table),t.resolve(n.key),u===e&&K(n.key),n},function(e){return n.$emit("$translateChangeError",{language:e}),t.reject(e),n.$emit("$translateChangeEnd",{language:e}),r.reject(e)}),V[e].finally(function(){le(e)}).catch(angular.noop)),t.promise)},X.resolveClientLocale=function(){return I()},X.storageKey=function(){return W()},X.isPostCompilingEnabled=function(){return x},X.isForceAsyncReloadEnabled=function(){return E},X.isKeepContent=function(){return O},X.refresh=function(e){function t(e){var t=Y(e);return V[e]=t,t.then(function(t){C[e]={},R(e,t.table),i[e]=!0},angular.noop),t}if(!h)throw new Error("Couldn't refresh translation table, no loader registered!");n.$emit("$translateRefreshStart",{language:e});var o=r.defer(),i={};if(o.promise.then(function(){for(var e in C)C.hasOwnProperty(e)&&(e in i||delete C[e]);l&&K(l)},angular.noop).finally(function(){n.$emit("$translateRefreshEnd",{language:e})}),e)C[e]?t(e).then(o.resolve,o.reject):o.reject();else{var s=a&&a.slice()||[];l&&s.indexOf(l)===-1&&s.push(l),r.all(s.map(t)).then(o.resolve,o.reject)}return o.promise},X.instant=function(e,t,n,r,i){var s=r&&r!==l?j(r)||r:l;if(null===e||angular.isUndefined(e))return e;if(r&&ce(r),angular.isArray(e)){for(var u={},c=0,d=e.length;c<d;c++)u[e[c]]=X.instant(e[c],t,n,r,i);return u}if(angular.isString(e)&&e.length<1)return e;e&&(e=F.apply(e));var p,h=[];o&&h.push(o),s&&h.push(s),a&&a.length&&(h=h.concat(a));for(var g=0,y=h.length;g<y;g++){var b=h[g];if(C[b]&&"undefined"!=typeof C[b][e]&&(p=se(e,t,n,s,i)),"undefined"!=typeof p)break}if(!p&&""!==p)if(m||v)p=G(e);else{p=P.interpolate(e,t,"filter",i);var w;f&&!D&&(w=te(e,t,i)),f&&!D&&w&&(p=w)}return p},X.versionInfo=function(){return N},X.loaderCache=function(){return y},X.directivePriority=function(){return B},X.statefulFilter=function(){return L},X.isReady=function(){return A};var de=r.defer();de.promise.then(function(){A=!0}),X.onReady=function(e){var t=r.defer();return angular.isFunction(e)&&t.promise.then(e),A?t.resolve():de.promise.then(t.resolve),t.promise},X.getAvailableLanguageKeys=function(){return w.length>0?w:null},X.getTranslationTable=function(e){return e=e||X.use(),e&&C[e]?angular.copy(C[e]):null};var fe=n.$on("$translateReady",function(){de.resolve(),fe(),fe=null}),pe=n.$on("$translateChangeEnd",function(){de.resolve(),pe(),pe=null});if(h){if(angular.equals(C,{})&&X.use()&&X.use(X.use()),a&&a.length)for(var he=function(e){return R(e.key,e.table),n.$emit("$translateChangeEnd",{language:e.key}),e},ge=0,me=a.length;ge<me;ge++){var ve=a[ge];!E&&C[ve]||(V[ve]=Y(ve).then(he))}}else n.$emit("$translateReady",{language:X.use()});return X}]}function r(e,t){"use strict";var n,r={},o="default";return r.setLocale=function(e){n=e},r.getInterpolationIdentifier=function(){return o},r.useSanitizeValueStrategy=function(e){return t.useStrategy(e),this},r.interpolate=function(n,r,o,i){r=r||{},r=t.sanitize(r,"params",i,o);var a;return angular.isNumber(n)?a=""+n:angular.isString(n)?(a=e(n)(r),a=t.sanitize(a,"text",i,o)):a="",a},r}function o(e,t,n,r,o){"use strict";var a=function(){return this.toString().replace(/^\s+|\s+$/g,"")};return{restrict:"AE",scope:!0,priority:e.directivePriority(),compile:function(s,l){var u=l.translateValues?l.translateValues:void 0,c=l.translateInterpolation?l.translateInterpolation:void 0,d=s[0].outerHTML.match(/translate-value-+/i),f="^(.*)("+t.startSymbol()+".*"+t.endSymbol()+")(.*)",p="^(.*)"+t.startSymbol()+"(.*)"+t.endSymbol()+"(.*)";return function(s,h,g){s.interpolateParams={},s.preText="",s.postText="",s.translateNamespace=i(s);var m={},v=function(e,t,n){if(t.translateValues&&angular.extend(e,r(t.translateValues)(s.$parent)),d)for(var o in n)if(Object.prototype.hasOwnProperty.call(t,o)&&"translateValue"===o.substr(0,14)&&"translateValues"!==o){var i=angular.lowercase(o.substr(14,1))+o.substr(15);e[i]=n[o]}},y=function(e){if(angular.isFunction(y._unwatchOld)&&(y._unwatchOld(),y._unwatchOld=void 0),angular.equals(e,"")||!angular.isDefined(e)){var n=a.apply(h.text()),r=n.match(f);if(angular.isArray(r)){s.preText=r[1],s.postText=r[3],m.translate=t(r[2])(s.$parent);var o=n.match(p);angular.isArray(o)&&o[2]&&o[2].length&&(y._unwatchOld=s.$watch(o[2],function(e){m.translate=e,T()}))}else m.translate=n?n:void 0}else m.translate=e;T()},b=function(e){g.$observe(e,function(t){m[e]=t,T()})};v(s.interpolateParams,g,l);var C=!0;g.$observe("translate",function(e){"undefined"==typeof e?y(""):""===e&&C||(m.translate=e,T()),C=!1});for(var w in g)g.hasOwnProperty(w)&&"translateAttr"===w.substr(0,13)&&w.length>13&&b(w);if(g.$observe("translateDefault",function(e){s.defaultText=e,T()}),u&&g.$observe("translateValues",function(e){e&&s.$parent.$watch(function(){angular.extend(s.interpolateParams,r(e)(s.$parent))})}),d){var S=function(e){g.$observe(e,function(t){var n=angular.lowercase(e.substr(14,1))+e.substr(15);s.interpolateParams[n]=t})};for(var $ in g)Object.prototype.hasOwnProperty.call(g,$)&&"translateValue"===$.substr(0,14)&&"translateValues"!==$&&S($)}var T=function(){for(var e in m)m.hasOwnProperty(e)&&void 0!==m[e]&&x(e,m[e],s,s.interpolateParams,s.defaultText,s.translateNamespace)},x=function(t,n,r,o,i,a){n?(a&&"."===n.charAt(0)&&(n=a+n),e(n,o,c,i,r.translateLanguage).then(function(e){E(e,r,!0,t)},function(e){E(e,r,!1,t)})):E(n,r,!1,t)},E=function(t,r,o,i){if(o||"undefined"!=typeof r.defaultText&&(t=r.defaultText),"translate"===i){(o||!o&&!e.isKeepContent()&&"undefined"==typeof g.translateKeepContent)&&h.empty().append(r.preText+t+r.postText);var a=e.isPostCompilingEnabled(),s="undefined"!=typeof l.translateCompile,u=s&&"false"!==l.translateCompile;(a&&!s||u)&&n(h.contents())(r)}else{var c=g.$attr[i];"data-"===c.substr(0,5)&&(c=c.substr(5)),c=c.substr(15),h.attr(c,t)}};(u||d||g.translateDefault)&&s.$watch("interpolateParams",T,!0),s.$on("translateLanguageChanged",T);var k=o.$on("$translateChangeSuccess",T);h.text().length?y(g.translate?g.translate:""):g.translate&&y(g.translate),T(),s.$on("$destroy",k)}}}}function i(e){"use strict";return e.translateNamespace?e.translateNamespace:e.$parent?i(e.$parent):void 0}function a(e,t){"use strict";return{restrict:"A",priority:e.directivePriority(),link:function(n,r,o){var i,a,l={},u=function(){angular.forEach(i,function(t,i){t&&(l[i]=!0,n.translateNamespace&&"."===t.charAt(0)&&(t=n.translateNamespace+t),e(t,a,o.translateInterpolation,void 0,n.translateLanguage).then(function(e){r.attr(i,e)},function(e){r.attr(i,e)}))}),angular.forEach(l,function(e,t){i[t]||(r.removeAttr(t),delete l[t])})};s(n,o.translateAttr,function(e){i=e},u),s(n,o.translateValues,function(e){a=e},u),o.translateValues&&n.$watch(o.translateValues,u,!0),n.$on("translateLanguageChanged",u);var c=t.$on("$translateChangeSuccess",u);u(),n.$on("$destroy",c)}}}function s(e,t,n,r){"use strict";t&&("::"===t.substr(0,2)?t=t.substr(2):e.$watch(t,function(e){n(e),r()},!0),n(e.$eval(t)))}function l(e){"use strict";return{compile:function(t){var n=function(t){t.addClass(e.cloakClassName())},r=function(t){t.removeClass(e.cloakClassName())};return n(t),function(t,o,i){var a=r.bind(this,o),s=n.bind(this,o);i.translateCloak&&i.translateCloak.length?i.$observe("translateCloak",function(t){e(t).then(a,s)}):e.onReady(a)}}}}function u(){"use strict";return{restrict:"A",scope:!0,compile:function(){return{pre:function(e,t,n){e.translateNamespace=i(e),e.translateNamespace&&"."===n.translateNamespace.charAt(0)?e.translateNamespace+=n.translateNamespace:e.translateNamespace=n.translateNamespace}}}}}function i(e){"use strict";return e.translateNamespace?e.translateNamespace:e.$parent?i(e.$parent):void 0}function c(){"use strict";return{restrict:"A",scope:!0,compile:function(){return function(e,t,n){n.$observe("translateLanguage",function(t){e.translateLanguage=t}),e.$watch("translateLanguage",function(){e.$broadcast("translateLanguageChanged")})}}}}function d(e,t){"use strict";var n=function(n,r,o,i){return angular.isObject(r)||(r=e(r)(this)),t.instant(n,r,o,i)};return t.statefulFilter()&&(n.$stateful=!0),n}function f(e){"use strict";return e("translations")}return e.$inject=["$translate"],n.$inject=["$STORAGE_KEY","$windowProvider","$translateSanitizationProvider","pascalprechtTranslateOverrider"],r.$inject=["$interpolate","$translateSanitization"],o.$inject=["$translate","$interpolate","$compile","$parse","$rootScope"],a.$inject=["$translate","$rootScope"],l.$inject=["$translate"],d.$inject=["$parse","$translate"],f.$inject=["$cacheFactory"],angular.module("pascalprecht.translate",["ng"]).run(e),e.displayName="runTranslate",angular.module("pascalprecht.translate").provider("$translateSanitization",t),angular.module("pascalprecht.translate").constant("pascalprechtTranslateOverrider",{}).provider("$translate",n),n.displayName="displayName",angular.module("pascalprecht.translate").factory("$translateDefaultInterpolation",r),r.displayName="$translateDefaultInterpolation",angular.module("pascalprecht.translate").constant("$STORAGE_KEY","NG_TRANSLATE_LANG_KEY"),angular.module("pascalprecht.translate").directive("translate",o),o.displayName="translateDirective",angular.module("pascalprecht.translate").directive("translateAttr",a),a.displayName="translateAttrDirective",angular.module("pascalprecht.translate").directive("translateCloak",l),l.displayName="translateCloakDirective",angular.module("pascalprecht.translate").directive("translateNamespace",u),u.displayName="translateNamespaceDirective",angular.module("pascalprecht.translate").directive("translateLanguage",c),c.displayName="translateLanguageDirective",angular.module("pascalprecht.translate").filter("translate",d),d.displayName="translateFilterFactory",angular.module("pascalprecht.translate").factory("$translationCache",f),f.displayName="$translationCache","pascalprecht.translate"}),!function(){"use strict";function e(e){return angular.isUndefined(e)||null===e}function t(){try{return require("moment")}catch(e){throw new Error("Please install moment via npm. Please reference to: https://github.com/urish/angular-moment")}}function n(n,r){if("undefined"==typeof r){if("function"!=typeof require)throw new Error("Moment cannot be found by angular-moment! Please reference to: https://github.com/urish/angular-moment");r=t()}return n.module("angularMoment",[]).constant("angularMomentConfig",{preprocess:null,timezone:null,format:null,statefulFilters:!0}).constant("moment",r).constant("amTimeAgoConfig",{withoutSuffix:!1,serverTime:null,titleFormat:null,fullDateThreshold:null,fullDateFormat:null}).directive("amTimeAgo",["$window","moment","amMoment","amTimeAgoConfig",function(t,r,o,i){return function(a,s,l){function u(){var e;if(g)e=g;else if(i.serverTime){var t=(new Date).getTime(),n=t-w+i.serverTime;e=r(n)}else e=r();return e}function c(){m&&(t.clearTimeout(m),m=null)}function d(e){var n=u().diff(e,"day"),r=b&&n>=b;if(r?s.text(e.format(C)):s.text(e.from(u(),v)),y&&T&&s.attr("title",e.local().format(y)),!r){var o=Math.abs(u().diff(e,"minute")),i=3600;1>o?i=1:60>o?i=30:180>o&&(i=300),m=t.setTimeout(function(){d(e)},1e3*i)}}function f(e){$&&s.attr("datetime",e)}function p(){if(c(),h){var e=o.preprocessDate(h);d(e),f(e.toISOString())}}var h,g,m=null,v=i.withoutSuffix,y=i.titleFormat,b=i.fullDateThreshold,C=i.fullDateFormat,w=(new Date).getTime(),S=l.amTimeAgo,$="TIME"===s[0].nodeName.toUpperCase(),T=!s.attr("title");a.$watch(S,function(t){return e(t)||""===t?(c(),void(h&&(s.text(""),f(""),h=null))):(h=t,void p())}),n.isDefined(l.amFrom)&&a.$watch(l.amFrom,function(t){g=e(t)||""===t?null:r(t),p()}),n.isDefined(l.amWithoutSuffix)&&a.$watch(l.amWithoutSuffix,function(e){"boolean"==typeof e?(v=e,p()):v=i.withoutSuffix}),l.$observe("amFullDateThreshold",function(e){b=e,p()}),l.$observe("amFullDateFormat",function(e){C=e,p()}),a.$on("$destroy",function(){c()}),a.$on("amMoment:localeChanged",function(){p()})}}]).service("amMoment",["moment","$rootScope","$log","angularMomentConfig",function(e,t,r,o){var i=null;this.changeLocale=function(r,o){var i=e.locale(r,o);return n.isDefined(r)&&t.$broadcast("amMoment:localeChanged"),i},this.changeTimezone=function(n){e.tz&&e.tz.setDefault?(e.tz.setDefault(n),t.$broadcast("amMoment:timezoneChanged")):r.warn("angular-moment: changeTimezone() works only with moment-timezone.js v0.3.0 or greater."),o.timezone=n,i=n},this.preprocessDate=function(t){return i!==o.timezone&&this.changeTimezone(o.timezone),o.preprocess?o.preprocess(t):e(!isNaN(parseFloat(t))&&isFinite(t)?parseInt(t,10):t)}}]).filter("amParse",["moment",function(e){return function(t,n){return e(t,n)}}]).filter("amFromUnix",["moment",function(e){return function(t){return e.unix(t)}}]).filter("amUtc",["moment",function(e){return function(t){return e.utc(t)}}]).filter("amUtcOffset",["amMoment",function(e){function t(t,n){return e.preprocessDate(t).utcOffset(n)}return t}]).filter("amLocal",["moment",function(e){return function(t){return e.isMoment(t)?t.local():null}}]).filter("amTimezone",["amMoment","angularMomentConfig","$log",function(e,t,n){function r(t,r){var o=e.preprocessDate(t);return r?o.tz?o.tz(r):(n.warn("angular-moment: named timezone specified but moment.tz() is undefined. Did you forget to include moment-timezone.js ?"),o):o}return r}]).filter("amCalendar",["moment","amMoment","angularMomentConfig",function(t,n,r){function o(t){if(e(t))return"";var r=n.preprocessDate(t);return r.isValid()?r.calendar():""}return o.$stateful=r.statefulFilters,o}]).filter("amDifference",["moment","amMoment","angularMomentConfig",function(t,n,r){function o(r,o,i,a){if(e(r))return"";var s=n.preprocessDate(r),l=e(o)?t():n.preprocessDate(o);return s.isValid()&&l.isValid()?s.diff(l,i,a):""}return o.$stateful=r.statefulFilters,o}]).filter("amDateFormat",["moment","amMoment","angularMomentConfig",function(t,n,r){function o(t,r){if(e(t))return"";var o=n.preprocessDate(t);return o.isValid()?o.format(r):""}return o.$stateful=r.statefulFilters,o}]).filter("amDurationFormat",["moment","angularMomentConfig",function(t,n){function r(n,r,o){return e(n)?"":t.duration(n,r).humanize(o)}return r.$stateful=n.statefulFilters,r}]).filter("amTimeAgo",["moment","amMoment","angularMomentConfig",function(t,n,r){function o(r,o,i){var a,s;return e(r)?"":(r=n.preprocessDate(r),a=t(r),a.isValid()?(s=t(i),!e(i)&&s.isValid()?a.from(s,o):a.fromNow(o)):"")}return o.$stateful=r.statefulFilters,o}]).filter("amSubtract",["moment","angularMomentConfig",function(t,n){function r(n,r,o){return e(n)?"":t(n).subtract(parseInt(r,10),o)}return r.$stateful=n.statefulFilters,r}]).filter("amAdd",["moment","angularMomentConfig",function(t,n){function r(n,r,o){return e(n)?"":t(n).add(parseInt(r,10),o)}return r.$stateful=n.statefulFilters,r}]).filter("amStartOf",["moment","angularMomentConfig",function(t,n){function r(n,r){return e(n)?"":t(n).startOf(r)}return r.$stateful=n.statefulFilters,r}]).filter("amEndOf",["moment","angularMomentConfig",function(t,n){function r(n,r){return e(n)?"":t(n).endOf(r)}return r.$stateful=n.statefulFilters,r}])}"function"==typeof define&&define.amd?define(["angular","moment"],n):"undefined"!=typeof module&&module&&module.exports?(n(require("angular"),require("moment")),module.exports="angularMoment"):n(angular,("undefined"!=typeof global?global:window).moment)}(),!function(){"use strict";function e(e,t,n,f){function p(t,n,o){o||!l(n)||u(n)||(o=n,n=void 0),this.protocols=n,this.url=t||"Missing URL",this.ssl=/(wss)/i.test(this.url),this.scope=o&&o.scope||e,this.rootScopeFailover=o&&o.rootScopeFailover&&!0,this.useApplyAsync=o&&o.useApplyAsync||!1,this.initialTimeout=o&&o.initialTimeout||500,this.maxTimeout=o&&o.maxTimeout||3e5,this.reconnectIfNotNormalClose=o&&o.reconnectIfNotNormalClose||!1,this._reconnectAttempts=0,this.sendQueue=[],this.onOpenCallbacks=[],this.onMessageCallbacks=[],this.onErrorCallbacks=[],this.onCloseCallbacks=[],r(this._readyStateConstants),t?this._connect():this._setInternalState(0)}return p.prototype._readyStateConstants={CONNECTING:0,OPEN:1,CLOSING:2,CLOSED:3,RECONNECT_ABORTED:4},p.prototype._normalCloseCode=1e3,p.prototype._reconnectableStatusCodes=[4e3],p.prototype.safeDigest=function(e){e&&!this.scope.$$phase&&this.scope.$digest()},p.prototype.bindToScope=function(t){var n=this;return t&&(this.scope=t,this.rootScopeFailover&&this.scope.$on("$destroy",function(){n.scope=e})),n},p.prototype._connect=function(e){(e||!this.socket||this.socket.readyState!==this._readyStateConstants.OPEN)&&(this.socket=f.create(this.url,this.protocols),this.socket.onmessage=angular.bind(this,this._onMessageHandler),this.socket.onopen=angular.bind(this,this._onOpenHandler),this.socket.onerror=angular.bind(this,this._onErrorHandler),this.socket.onclose=angular.bind(this,this._onCloseHandler))},p.prototype.fireQueue=function(){for(;this.sendQueue.length&&this.socket.readyState===this._readyStateConstants.OPEN;){var e=this.sendQueue.shift();this.socket.send(i(e.message)?e.message:JSON.stringify(e.message)),e.deferred.resolve()}},p.prototype.notifyOpenCallbacks=function(e){for(var t=0;t<this.onOpenCallbacks.length;t++)this.onOpenCallbacks[t].call(this,e)},p.prototype.notifyCloseCallbacks=function(e){for(var t=0;t<this.onCloseCallbacks.length;t++)this.onCloseCallbacks[t].call(this,e)},p.prototype.notifyErrorCallbacks=function(e){for(var t=0;t<this.onErrorCallbacks.length;t++)this.onErrorCallbacks[t].call(this,e)},p.prototype.onOpen=function(e){return this.onOpenCallbacks.push(e),this},p.prototype.onClose=function(e){return this.onCloseCallbacks.push(e),this},p.prototype.onError=function(e){return this.onErrorCallbacks.push(e),this},p.prototype.onMessage=function(e,t){if(!a(e))throw new Error("Callback must be a function");if(t&&s(t.filter)&&!i(t.filter)&&!(t.filter instanceof RegExp))throw new Error("Pattern must be a string or regular expression");return this.onMessageCallbacks.push({fn:e,pattern:t?t.filter:void 0,autoApply:!t||t.autoApply}),this},p.prototype._onOpenHandler=function(e){this._reconnectAttempts=0,this.notifyOpenCallbacks(e),this.fireQueue()},p.prototype._onCloseHandler=function(e){var t=this;t.useApplyAsync?t.scope.$applyAsync(function(){t.notifyCloseCallbacks(e)}):(t.notifyCloseCallbacks(e),t.safeDigest(autoApply)),(this.reconnectIfNotNormalClose&&e.code!==this._normalCloseCode||this._reconnectableStatusCodes.indexOf(e.code)>-1)&&this.reconnect();
},p.prototype._onErrorHandler=function(e){var t=this;t.useApplyAsync?t.scope.$applyAsync(function(){t.notifyErrorCallbacks(e)}):(t.notifyErrorCallbacks(e),t.safeDigest(autoApply))},p.prototype._onMessageHandler=function(e){function t(e,t,n){n=d.call(arguments,2),o.useApplyAsync?o.scope.$applyAsync(function(){e.apply(o,n)}):(e.apply(o,n),o.safeDigest(t))}for(var n,r,o=this,a=0;a<o.onMessageCallbacks.length;a++)r=o.onMessageCallbacks[a],n=r.pattern,n?i(n)&&e.data===n?t(r.fn,r.autoApply,e):n instanceof RegExp&&n.exec(e.data)&&t(r.fn,r.autoApply,e):t(r.fn,r.autoApply,e)},p.prototype.close=function(e){return(e||!this.socket.bufferedAmount)&&this.socket.close(),this},p.prototype.send=function(e){function n(e){e.cancel=r;var t=e.then;return e.then=function(){var e=t.apply(this,arguments);return n(e)},e}function r(t){return i.sendQueue.splice(i.sendQueue.indexOf(e),1),o.reject(t),i}var o=t.defer(),i=this,a=n(o.promise);return i.readyState===i._readyStateConstants.RECONNECT_ABORTED?o.reject("Socket connection has been closed"):(i.sendQueue.push({message:e,deferred:o}),i.fireQueue()),f.isMocked&&f.isMocked()&&f.isConnected(this.url)&&this._onMessageHandler(f.mockSend()),a},p.prototype.reconnect=function(){this.close();var e=this._getBackoffDelay(++this._reconnectAttempts),t=e/1e3;return console.log("Reconnecting in "+t+" seconds"),n(angular.bind(this,this._connect),e),this},p.prototype._getBackoffDelay=function(e){var t=Math.random()+1,n=this.initialTimeout,r=2,o=e,i=this.maxTimeout;return Math.floor(Math.min(t*n*Math.pow(r,o),i))},p.prototype._setInternalState=function(e){if(Math.floor(e)!==e||0>e||e>4)throw new Error("state must be an integer between 0 and 4, got: "+e);o||(this.readyState=e||this.socket.readyState),this._internalConnectionState=e,c(this.sendQueue,function(e){e.deferred.reject("Message cancelled due to closed socket connection")})},o&&o(p.prototype,"readyState",{get:function(){return this._internalConnectionState||this.socket.readyState},set:function(){throw new Error("The readyState property is read-only")}}),function(e,t,n){return new p(e,t,n)}}function t(e,t){this.create=function(t,n){var r,o,i=/wss?:\/\//.exec(t);if(!i)throw new Error("Invalid url provided");if("object"==typeof exports&&require)try{o=require("ws"),r=o.Client||o.client||o}catch(e){}return r=r||e.WebSocket||e.MozWebSocket,n?new r(t,n):new r(t)},this.createWebSocketBackend=function(e,n){return t.warn("Deprecated: Please use .create(url, protocols)"),this.create(e,n)}}var n=angular.noop,r=Object.freeze?Object.freeze:n,o=Object.defineProperty,i=angular.isString,a=angular.isFunction,s=angular.isDefined,l=angular.isObject,u=angular.isArray,c=angular.forEach,d=Array.prototype.slice;Array.prototype.indexOf||(Array.prototype.indexOf=function(e){var t=this.length>>>0,n=Number(arguments[1])||0;for(n=0>n?Math.ceil(n):Math.floor(n),0>n&&(n+=t);t>n;n++)if(n in this&&this[n]===e)return n;return-1}),angular.module("ngWebSocket",[]).factory("$websocket",["$rootScope","$q","$timeout","$websocketBackend",e]).factory("WebSocket",["$rootScope","$q","$timeout","WebsocketBackend",e]).service("$websocketBackend",["$window","$log",t]).service("WebSocketBackend",["$window","$log",t]),angular.module("angular-websocket",["ngWebSocket"]),"object"==typeof module&&"function"!=typeof define&&(module.exports=angular.module("ngWebSocket"))}(),angular.module("ab-base64",[]).constant("base64",function(){var e={alphabet:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",lookup:null,ie:/MSIE /.test(navigator.userAgent),ieo:/MSIE [67]/.test(navigator.userAgent),encode:function(t){var n,r,o,i,a=e.toUtf8(t),s=-1,l=a.length,u=[,,,];if(e.ie){for(n=[];++s<l;)r=a[s],o=a[++s],u[0]=r>>2,u[1]=(3&r)<<4|o>>4,isNaN(o)?u[2]=u[3]=64:(i=a[++s],u[2]=(15&o)<<2|i>>6,u[3]=isNaN(i)?64:63&i),n.push(e.alphabet.charAt(u[0]),e.alphabet.charAt(u[1]),e.alphabet.charAt(u[2]),e.alphabet.charAt(u[3]));return n.join("")}for(n="";++s<l;)r=a[s],o=a[++s],u[0]=r>>2,u[1]=(3&r)<<4|o>>4,isNaN(o)?u[2]=u[3]=64:(i=a[++s],u[2]=(15&o)<<2|i>>6,u[3]=isNaN(i)?64:63&i),n+=e.alphabet[u[0]]+e.alphabet[u[1]]+e.alphabet[u[2]]+e.alphabet[u[3]];return n},decode:function(t){if(t=t.replace(/\s/g,""),t.length%4)throw new Error("InvalidLengthError: decode failed: The string to be decoded is not the correct length for a base64 encoded string.");if(/[^A-Za-z0-9+\/=\s]/g.test(t))throw new Error("InvalidCharacterError: decode failed: The string contains characters invalid in a base64 encoded string.");var n,r=e.fromUtf8(t),o=0,i=r.length;if(e.ieo){for(n=[];i>o;)n.push(r[o]<128?String.fromCharCode(r[o++]):r[o]>191&&r[o]<224?String.fromCharCode((31&r[o++])<<6|63&r[o++]):String.fromCharCode((15&r[o++])<<12|(63&r[o++])<<6|63&r[o++]));return n.join("")}for(n="";i>o;)n+=String.fromCharCode(r[o]<128?r[o++]:r[o]>191&&r[o]<224?(31&r[o++])<<6|63&r[o++]:(15&r[o++])<<12|(63&r[o++])<<6|63&r[o++]);return n},toUtf8:function(e){var t,n=-1,r=e.length,o=[];if(/^[\x00-\x7f]*$/.test(e))for(;++n<r;)o.push(e.charCodeAt(n));else for(;++n<r;)t=e.charCodeAt(n),128>t?o.push(t):2048>t?o.push(t>>6|192,63&t|128):o.push(t>>12|224,t>>6&63|128,63&t|128);return o},fromUtf8:function(t){var n,r=-1,o=[],i=[,,,];if(!e.lookup){for(n=e.alphabet.length,e.lookup={};++r<n;)e.lookup[e.alphabet.charAt(r)]=r;r=-1}for(n=t.length;++r<n&&(i[0]=e.lookup[t.charAt(r)],i[1]=e.lookup[t.charAt(++r)],o.push(i[0]<<2|i[1]>>4),i[2]=e.lookup[t.charAt(++r)],64!==i[2])&&(o.push((15&i[1])<<4|i[2]>>2),i[3]=e.lookup[t.charAt(++r)],64!==i[3]);)o.push((3&i[2])<<6|i[3]);return o}},t={decode:function(t){t=t.replace(/-/g,"+").replace(/_/g,"/");var n=t.length%4;if(n){if(1===n)throw new Error("InvalidLengthError: Input base64url string is the wrong length to determine padding");t+=new Array(5-n).join("=")}return e.decode(t)},encode:function(t){var n=e.encode(t);return n.replace(/\+/g,"-").replace(/\//g,"_").split("=",1)[0]}};return{decode:e.decode,encode:e.encode,urldecode:t.decode,urlencode:t.encode}}()),/**
 * An Angular module that gives you access to the browsers local storage
 * @version v0.2.6 - 2016-03-16
 * @link https://github.com/grevory/angular-local-storage
 * @author grevory <greg@gregpike.ca>
 * @license MIT License, http://www.opensource.org/licenses/MIT
 */
!function(e,t){var n=t.isDefined,r=t.isUndefined,o=t.isNumber,i=t.isObject,a=t.isArray,s=t.extend,l=t.toJson;t.module("LocalStorageModule",[]).provider("localStorageService",function(){this.prefix="ls",this.storageType="localStorage",this.cookie={expiry:30,path:"/"},this.notify={setItem:!0,removeItem:!1},this.setPrefix=function(e){return this.prefix=e,this},this.setStorageType=function(e){return this.storageType=e,this},this.setStorageCookie=function(e,t){return this.cookie.expiry=e,this.cookie.path=t,this},this.setStorageCookieDomain=function(e){return this.cookie.domain=e,this},this.setNotify=function(e,t){return this.notify={setItem:e,removeItem:t},this},this.$get=["$rootScope","$window","$document","$parse",function(e,t,u,c){var d,f=this,p=f.prefix,h=f.cookie,g=f.notify,m=f.storageType;u?u[0]&&(u=u[0]):u=document,"."!==p.substr(-1)&&(p=p?p+".":"");var v=function(e){return p+e},y=function(){try{var n=m in t&&null!==t[m],r=v("__"+Math.round(1e7*Math.random()));return n&&(d=t[m],d.setItem(r,""),d.removeItem(r)),n}catch(t){return m="cookie",e.$broadcast("LocalStorageModule.notification.error",t.message),!1}}(),b=function(t,n){if(n=r(n)?null:l(n),!y||"cookie"===f.storageType)return y||e.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED"),g.setItem&&e.$broadcast("LocalStorageModule.notification.setitem",{key:t,newvalue:n,storageType:"cookie"}),x(t,n);try{d&&d.setItem(v(t),n),g.setItem&&e.$broadcast("LocalStorageModule.notification.setitem",{key:t,newvalue:n,storageType:f.storageType})}catch(r){return e.$broadcast("LocalStorageModule.notification.error",r.message),x(t,n)}return!0},C=function(t){if(!y||"cookie"===f.storageType)return y||e.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED"),E(t);var n=d?d.getItem(v(t)):null;if(!n||"null"===n)return null;try{return JSON.parse(n)}catch(e){return n}},w=function(){var t,n;for(t=0;t<arguments.length;t++)if(n=arguments[t],y&&"cookie"!==f.storageType)try{d.removeItem(v(n)),g.removeItem&&e.$broadcast("LocalStorageModule.notification.removeitem",{key:n,storageType:f.storageType})}catch(t){e.$broadcast("LocalStorageModule.notification.error",t.message),k(n)}else y||e.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED"),g.removeItem&&e.$broadcast("LocalStorageModule.notification.removeitem",{key:n,storageType:"cookie"}),k(n)},S=function(){if(!y)return e.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED"),[];var t=p.length,n=[];for(var r in d)if(r.substr(0,t)===p)try{n.push(r.substr(t))}catch(t){return e.$broadcast("LocalStorageModule.notification.error",t.Description),[]}return n},$=function(t){var n=p?new RegExp("^"+p):new RegExp,r=t?new RegExp(t):new RegExp;if(!y||"cookie"===f.storageType)return y||e.$broadcast("LocalStorageModule.notification.warning","LOCAL_STORAGE_NOT_SUPPORTED"),A();var o=p.length;for(var i in d)if(n.test(i)&&r.test(i.substr(o)))try{w(i.substr(o))}catch(t){return e.$broadcast("LocalStorageModule.notification.error",t.message),A()}return!0},T=function(){try{return t.navigator.cookieEnabled||"cookie"in u&&(u.cookie.length>0||(u.cookie="test").indexOf.call(u.cookie,"test")>-1)}catch(t){return e.$broadcast("LocalStorageModule.notification.error",t.message),!1}}(),x=function(t,n,s){if(r(n))return!1;if((a(n)||i(n))&&(n=l(n)),!T)return e.$broadcast("LocalStorageModule.notification.error","COOKIES_NOT_SUPPORTED"),!1;try{var c="",d=new Date,f="";if(null===n?(d.setTime(d.getTime()+-864e5),c="; expires="+d.toGMTString(),n=""):o(s)&&0!==s?(d.setTime(d.getTime()+24*s*60*60*1e3),c="; expires="+d.toGMTString()):0!==h.expiry&&(d.setTime(d.getTime()+24*h.expiry*60*60*1e3),c="; expires="+d.toGMTString()),t){var p="; path="+h.path;h.domain&&(f="; domain="+h.domain),u.cookie=v(t)+"="+encodeURIComponent(n)+c+p+f}}catch(t){return e.$broadcast("LocalStorageModule.notification.error",t.message),!1}return!0},E=function(t){if(!T)return e.$broadcast("LocalStorageModule.notification.error","COOKIES_NOT_SUPPORTED"),!1;for(var n=u.cookie&&u.cookie.split(";")||[],r=0;r<n.length;r++){for(var o=n[r];" "===o.charAt(0);)o=o.substring(1,o.length);if(0===o.indexOf(v(t)+"=")){var i=decodeURIComponent(o.substring(p.length+t.length+1,o.length));try{return JSON.parse(i)}catch(e){return i}}}return null},k=function(e){x(e,null)},A=function(){for(var e=null,t=p.length,n=u.cookie.split(";"),r=0;r<n.length;r++){for(e=n[r];" "===e.charAt(0);)e=e.substring(1,e.length);var o=e.substring(t,e.indexOf("="));k(o)}},O=function(){return m},B=function(e,t,r,o){o=o||t;var a=C(o);return null===a&&n(r)?a=r:i(a)&&i(r)&&(a=s(a,r)),c(t).assign(e,a),e.$watch(t,function(e){b(o,e)},i(e[t]))},L=function(){for(var e=0,n=t[m],r=0;r<n.length;r++)0===n.key(r).indexOf(p)&&e++;return e};return{isSupported:y,getStorageType:O,set:b,add:b,get:C,keys:S,remove:w,clearAll:$,bind:B,deriveKey:v,length:L,cookie:{isSupported:T,set:x,add:x,get:E,remove:k,clearAll:A}}}]})}(window,window.angular),/*! Angular notification v1.1.1 | (c) 2013 Greg Bergé | License MIT */
angular.module("notification",[]).provider("$notification",$notificationProvider),/**
 * angular-ui-notification - Angular.js service providing simple notifications using Bootstrap 3 styles with css transitions for animating
 * @author Alex_Crack
 * @version v0.2.0
 * @link https://github.com/alexcrack/angular-ui-notification
 * @license MIT
 */
angular.module("ui-notification",[]),angular.module("ui-notification").provider("Notification",function(){this.options={delay:5e3,startTop:10,startRight:10,verticalSpacing:10,horizontalSpacing:10,positionX:"right",positionY:"top",replaceMessage:!1,templateUrl:"angular-ui-notification.html",onClose:void 0,closeOnClick:!0,maxCount:0},this.setOptions=function(e){if(!angular.isObject(e))throw new Error("Options should be an object!");this.options=angular.extend({},this.options,e)},this.$get=["$timeout","$http","$compile","$templateCache","$rootScope","$injector","$sce","$q","$window",function(e,t,n,r,o,i,a,s,l){var u=this.options,c=u.startTop,d=u.startRight,f=u.verticalSpacing,p=u.horizontalSpacing,h=u.delay,g=[],m=!1,v=function(i,v){var y=s.defer();return"object"!=typeof i&&(i={message:i}),i.scope=i.scope?i.scope:o,i.template=i.templateUrl?i.templateUrl:u.templateUrl,i.delay=angular.isUndefined(i.delay)?h:i.delay,i.type=v||u.type||"",i.positionY=i.positionY?i.positionY:u.positionY,i.positionX=i.positionX?i.positionX:u.positionX,i.replaceMessage=i.replaceMessage?i.replaceMessage:u.replaceMessage,i.onClose=i.onClose?i.onClose:u.onClose,i.closeOnClick=null!==i.closeOnClick&&void 0!==i.closeOnClick?i.closeOnClick:u.closeOnClick,t.get(i.template,{cache:r}).success(function(t){function r(e){["-webkit-transition","-o-transition","transition"].forEach(function(t){h.css(t,e)})}var o=i.scope.$new();o.message=a.trustAsHtml(i.message),o.title=a.trustAsHtml(i.title),o.t=i.type.substr(0,1),o.delay=i.delay,o.onClose=i.onClose;var s=function(){for(var e=0,t=0,n=c,r=d,o=[],a=g.length-1;a>=0;a--){var s=g[a];if(i.replaceMessage&&a<g.length-1)s.addClass("killed");else{var l=parseInt(s[0].offsetHeight),h=parseInt(s[0].offsetWidth),m=o[s._positionY+s._positionX];v+l>window.innerHeight&&(m=c,t++,e=0);var v=n=m?0===e?m:m+f:c,y=r+t*(p+h);s.css(s._positionY,v+"px"),"center"==s._positionX?s.css("left",parseInt(window.innerWidth/2-h/2)+"px"):s.css(s._positionX,y+"px"),o[s._positionY+s._positionX]=v+l,u.maxCount>0&&g.length>u.maxCount&&0===a&&s.scope().kill(!0),e++}}},h=n(t)(o);h._positionY=i.positionY,h._positionX=i.positionX,h.addClass(i.type);var v=function(e){e=e.originalEvent||e,("click"===e.type||"opacity"===e.propertyName&&e.elapsedTime>=1)&&(o.onClose&&o.$apply(o.onClose(h)),h.remove(),g.splice(g.indexOf(h),1),o.$destroy(),s())};i.closeOnClick&&(h.addClass("clickable"),h.bind("click",v)),h.bind("webkitTransitionEnd oTransitionEnd otransitionend transitionend msTransitionEnd",v),angular.isNumber(i.delay)&&e(function(){h.addClass("killed")},i.delay),r("none"),angular.element(document.getElementsByTagName("body")).append(h);var b=-(parseInt(h[0].offsetHeight)+50);if(h.css(h._positionY,b+"px"),g.push(h),"center"==i.positionX){var C=parseInt(h[0].offsetWidth);h.css("left",parseInt(window.innerWidth/2-C/2)+"px")}e(function(){r("")}),o._templateElement=h,o.kill=function(t){t?(o.onClose&&o.$apply(o.onClose(o._templateElement)),g.splice(g.indexOf(o._templateElement),1),o._templateElement.remove(),o.$destroy(),e(s)):o._templateElement.addClass("killed")},e(s),m||(angular.element(l).bind("resize",function(){e(s)}),m=!0),y.resolve(o)}).error(function(e){throw new Error("Template ("+i.template+") could not be loaded. "+e)}),y.promise};return v.primary=function(e){return this(e,"primary")},v.error=function(e){return this(e,"error")},v.success=function(e){return this(e,"success")},v.info=function(e){return this(e,"info")},v.warning=function(e){return this(e,"warning")},v.clearAll=function(){angular.forEach(g,function(e){e.addClass("killed")})},v}]}),angular.module("ui-notification").run(["$templateCache",function(e){e.put("angular-ui-notification.html",'<div class="ui-notification"><h3 ng-show="title" ng-bind-html="title"></h3><div class="message" ng-bind-html="message"></div></div>')}]),angular.module("angularBittorrentPeerid",[]),angular.module("angularBittorrentPeerid").run(function(){"function"!=typeof String.prototype.endsWith&&(String.prototype.endsWith=function(e){return this.slice(-e.length)===e}),"function"!=typeof String.prototype.startsWith&&(String.prototype.startsWith=function(e,t){return t=t||0,this.slice(t,t+e.length)===e})}),angular.module("angularBittorrentPeerid").factory("peeridUtils",function(){function e(e){var t=e.charCodeAt(0);return t>="0".charCodeAt(0)&&t<="9".charCodeAt(0)}function t(e){var t=e.toLowerCase().charCodeAt(0);return t>="a".charCodeAt(0)&&t<="z".charCodeAt(0)}function n(n){return e(n)||t(n)||"."===n}function r(e,t){t=t||0;for(var n=""+(255&e);n.length<t;)n="0"+n;return n}return{getUtf8Data:function(e){var t,n,r=[];for(t=0;t<e.length;t++)n=e.charCodeAt(t),128>n?r.push(n):2048>n?r.push(192|n>>6,128|63&n):r.push(224|n>>12,128|63&n>>6,128|63&n);return r},isAzStyle:function(e){return"-"===e.charAt(0)&&("-"===e.charAt(7)||("FG"===e.substring(1,3)||("LH"===e.substring(1,3)||("NE"===e.substring(1,3)||("KT"===e.substring(1,3)||"SP"===e.substring(1,3))))))},isShadowStyle:function(r){var o,i,a;if("-"!==r.charAt(5))return!1;if(!t(r.charAt(0)))return!1;if(!e(r.charAt(1))&&"-"!==r.charAt(1))return!1;for(o=4;o>0&&"-"===r.charAt(o);o--);for(i=1;o>=i;i++){if(a=r.charAt(i),"-"===a)return!1;if(null===n(a))return!1}return!0},isMainlineStyle:function(e){return"-"===e.charAt(2)&&"-"===e.charAt(7)&&("-"===e.charAt(4)||"-"===e.charAt(5))},isPossibleSpoofClient:function(e){return e.endsWith("UDP0")||e.endsWith("HTTPBT")},decodeNumericValueOfByte:r,getAzStyleVersionNumber:function(e,t){return"function"==typeof t?t(e):null},getShadowStyleVersionNumber:function(){return null},decodeBitSpiritClient:function(e,t){if("BS"!==e.substring(2,4))return null;var n=""+t[1];return"0"===n&&(n=1),{client:"BitSpirit",version:n}},decodeBitCometClient:function(e,t){var n,o,i,a,s="";if(e.startsWith("exbc"))s="";else if(e.startsWith("FUTB"))s="(Solidox Mod)";else{if(!e.startsWith("xUTB"))return null;s="(Mod 2)"}return n="LORD"===e.substring(6,10),o=n?"BitLord":"BitComet",i=r(t[4]),a=n&&"0"!==i?1:2,{client:o+(s?" "+s:""),version:i+"."+r(t[5],a)}},identifyAwkwardClient:function(e,t){var n,r,o=20;for(n=0;20>n;++n)if(t[n]>0){o=n;break}if(0===o){for(r=!0,n=0;16>n;++n)if(0===t[n]){r=!1;break}if(r){for(n=16;20>n;++n)if(t[n]!==(t[n%16]^t[15-n%16])){r=!1;break}if(r)return{client:"Shareaza"}}}return 9===o&&3===t[9]&&3===t[10]&&3===t[11]?{client:"I2PSnark"}:12===o&&97===t[12]&&97===t[13]?{client:"Experimental",version:"3.2.1b2"}:12===o&&0===t[12]&&0===t[13]?{client:"Experimental",version:"3.1"}:12===o?{client:"Mainline"}:null}}}),angular.module("angularBittorrentPeerid").provider("bittorrentPeeridService",function(){var e="unknown",t="fake",n={},r={},o={},i={},a={},s=[],l=function(e){return e[0]+"."+e[1]+"."+e[2]},u=function(e){var t="ABCDE";return isNaN(e[2])?e[0]+"."+e[1]+".1"+t.indexOf(e[2]):e[0]+"."+e[1]+"."+e[2]},c=function(e){var t=e[3];return t="B"==t?"Beta":"A"==t?"Alpha":"",e[0]+"."+e[1]+"."+e[2]+" "+t},d=function(e){return e[0]+"."+e[1]+"."+e[2]+"."+e[3]},f=function(e){return e[0]+e[1]+"."+e[2]+e[3]},p=function(e){return e[1]+"."+e[2]+e[3]},h="1.2.3=[RD].4",g=function(e){return"0"==e[0]&&"0"==e[1]&&"0"==e[2]?"0."+e[3]:"0"==e[0]&&"0"==e[1]?"0."+e[2]+e[3]:e[0]+"."+e[1]+e[2]+("Z"==e[3]||"X"==e[3]?"+":"")},m=function(e){var t="";return t+="0"==e[0]?e[1]+".":""+e[0]+e[1]+".",t+="0"==e[2]?e[3]:""+e[2]+e[3]},v="2.33.4",y="NO_VERSION",b=this.addAzStyle=function(e,t,o){o=o||d,n[e]=t,r[t]=o},C=this.addShadowStyle=function(e,t,n){n=n||l,o[e]=t,i[t]=n},w=this.addMainlineStyle=function(e,t){a[e]=t},S=this.addSimpleClient=function(e,t,n,r){("number"==typeof n||"undefined"==typeof n)&&(r=n,n=t,t=void 0),s.push({id:n,client:e,version:t,position:r||0})};!function(){b("A~","Ares",l),b("AG","Ares",l),b("AN","Ares",d),b("AR","Ares"),b("AV","Avicora"),b("AX","BitPump",f),b("AT","Artemis"),b("AZ","Vuze",d),b("BB","BitBuddy","1.234"),b("BC","BitComet",p),b("BE","BitTorrent SDK"),b("BF","BitFlu",y),b("BG","BTG",d),b("bk","BitKitten (libtorrent)"),b("BR","BitRocket","1.2(34)"),b("BS","BTSlave"),b("BT","BitTorrent",c),b("BW","BitWombat"),b("BX","BittorrentX"),b("CB","Shareaza Plus"),b("CD","Enhanced CTorrent",f),b("CT","CTorrent","1.2.34"),b("DP","Propogate Data Client"),b("DE","Deluge",u),b("EB","EBit"),b("ES","Electric Sheep",l),b("FC","FileCroc"),b("FG","FlashGet",p),b("FT","FoxTorrent/RedSwoosh"),b("GR","GetRight","1.2"),b("GS","GSTorrent"),b("HL","Halite",l),b("HN","Hydranode"),b("KG","KGet"),b("KT","KTorrent",h),b("LC","LeechCraft"),b("LH","LH-ABC"),b("LK","linkage",l),b("LP","Lphant",f),b("LT","libtorrent (Rasterbar)",v),b("lt","libTorrent (Rakshasa)",v),b("LW","LimeWire",y),b("MO","MonoTorrent"),b("MP","MooPolice",l),b("MR","Miro"),b("MT","MoonlightTorrent"),b("NE","BT Next Evolution",l),b("NX","Net Transport"),b("OS","OneSwarm",d),b("OT","OmegaTorrent"),b("PC","CacheLogic","12.3-4"),b("PT","Popcorn Time"),b("PD","Pando"),b("PE","PeerProject"),b("pX","pHoeniX"),b("qB","qBittorrent",u),b("QD","qqdownload"),b("RT","Retriever"),b("RZ","RezTorrent"),b("S~","Shareaza alpha/beta"),b("SB","SwiftBit"),b("SD","迅雷在线 (Xunlei)"),b("SG","GS Torrent",d),b("SN","ShareNET"),b("SP","BitSpirit",l),b("SS","SwarmScope"),b("ST","SymTorrent","2.34"),b("st","SharkTorrent"),b("SZ","Shareaza"),b("TN","Torrent.NET"),b("TR","Transmission",g),b("TS","TorrentStorm"),b("TT","TuoTu",l),b("UL","uLeecher!"),b("UE","µTorrent Embedded",c),b("UT","µTorrent",c),b("UM","µTorrent Mac",c),b("WD","WebTorrent Desktop",m),b("WT","Bitlet"),b("WW","WebTorrent",m),b("WY","FireTorrent"),b("VG","哇嘎 (Vagaa)",d),b("XL","迅雷在线 (Xunlei)"),b("XT","XanTorrent"),b("XF","Xfplay",g),b("XX","XTorrent","1.2.34"),b("XC","XTorrent","1.2.34"),b("ZT","ZipTorrent"),b("7T","aTorrent"),b("ZO","Zona",d),b("#@","Invalid PeerID"),C("A","ABC"),C("O","Osprey Permaseed"),C("Q","BTQueue"),C("R","Tribler"),C("S","Shad0w"),C("T","BitTornado"),C("U","UPnP NAT"),w("M","Mainline"),w("Q","Queen Bee"),S("µTorrent","1.7.0 RC","-UT170-"),S("Azureus","1","Azureus"),S("Azureus","2.0.3.2","Azureus",5),S("Aria","2","-aria2-"),S("BitTorrent Plus!","II","PRC.P---"),S("BitTorrent Plus!","P87.P---"),S("BitTorrent Plus!","S587Plus"),S("BitTyrant (Azureus Mod)","AZ2500BT"),S("Blizzard Downloader","BLZ"),S("BTGetit","BG",10),S("BTugaXP","btuga"),S("BTugaXP","BTuga",5),S("BTugaXP","oernu"),S("Deadman Walking","BTDWV-"),S("Deadman","Deadman Walking-"),S("External Webseed","Ext"),S("G3 Torrent","-G3"),S("GreedBT","2.7.1","271-"),S("Hurricane Electric","arclight"),S("HTTP Seed","-WS"),S("JVtorrent","10-------"),S("Limewire","LIME"),S("Martini Man","martini"),S("Pando","Pando"),S("PeerApp","PEERAPP"),S("SimpleBT","btfans",4),S("Swarmy","a00---0"),S("Swarmy","a02---0"),S("Teeweety","T00---0"),S("TorrentTopia","346-"),S("XanTorrent","DansClient"),S("MediaGet","-MG1"),S("MediaGet","2.1","-MG21"),S("Amazon AWS S3","S3-"),S("BitTorrent DNA","DNA"),S("Opera","OP"),S("Opera","O"),S("Burst!","Mbrst"),S("TurboBT","turbobt"),S("BT Protocol Daemon","btpd"),S("Plus!","Plus"),S("XBT","XBT"),S("BitsOnWheels","-BOW"),S("eXeem","eX"),S("MLdonkey","-ML"),S("Bitlet","BitLet"),S("AllPeers","AP"),S("BTuga Revolution","BTM"),S("Rufus","RS",2),S("BitMagnet","BM",2),S("QVOD","QVOD"),S("Top-BT","TB"),S("Tixati","TIX"),S("folx","-FL"),S("µTorrent Mac","-UM"),S("µTorrent","-UT")}(),this.$get=["peeridUtils",function(i){var l=function(e){return n[e.substring(1,3)]},u=function(e){return o[e.substring(0,1)]},c=function(e){return a[e.substring(0,1)]},d=function(e){var t,n;for(t=0;t<s.length;++t)if(n=s[t],e.startsWith(n.id,n.position))return n;return null},f=function(e,t){var n=r[e];return n?i.getAzStyleVersionNumber(t.substring(3,7),n):null},p=function(n){var r=i.getUtf8Data(n),o=null,a=null,s=null;return i.isPossibleSpoofClient(n)?(o=i.decodeBitSpiritClient(n,r))?o:(o=i.decodeBitCometClient(n,r))?o:{client:"BitSpirit?"}:i.isAzStyle(n)&&(o=l(n))?(a=f(o,n),o.startsWith("ZipTorrent")&&n.startsWith("bLAde",8)?{client:e+" ["+t+": "+name+"]",version:a}:"µTorrent"===o&&"6.0 Beta"===a?{client:"Mainline",version:"6.0 Beta"}:o.startsWith("libTorrent (Rakshasa)")?{client:o+" / rTorrent*",version:a}:{client:o,version:a}):i.isShadowStyle(n)&&(o=u(n))?{client:o}:i.isMainlineStyle(n)&&(o=c(n))?{client:o}:(o=i.decodeBitSpiritClient(n,r))?o:(o=i.decodeBitCometClient(n,r))?o:(s=d(n))?(o=s.client,{client:o,version:s.version}):(o=i.identifyAwkwardClient(n,r))?o:{client:"unknown"}};return{parseClient:p}}]}),angular.module("cgBusy",[]),angular.module("cgBusy").factory("_cgBusyTrackerFactory",["$timeout","$q",function(e,t){return function(){var n={};n.promises=[],n.delayPromise=null,n.durationPromise=null,n.delayJustFinished=!1,n.reset=function(t){n.minDuration=t.minDuration,n.promises=[],angular.forEach(t.promises,function(e){e&&!e.$cgBusyFulfilled&&r(e)}),0!==n.promises.length&&(n.delayJustFinished=!1,t.delay&&(n.delayPromise=e(function(){n.delayPromise=null,n.delayJustFinished=!0},parseInt(t.delay,10))),t.minDuration&&(n.durationPromise=e(function(){n.durationPromise=null},parseInt(t.minDuration,10)+(t.delay?parseInt(t.delay,10):0))))},n.isPromise=function(e){var t=e&&(e.then||e.$then||e.$promise&&e.$promise.then);return"undefined"!=typeof t},n.callThen=function(e,n,r){var o;e.then||e.$then?o=e:e.$promise?o=e.$promise:e.denodeify&&(o=t.when(e));var i=o.then||o.$then;i.call(o,n,r)};var r=function(e){if(!n.isPromise(e))throw new Error("cgBusy expects a promise (or something that has a .promise or .$promise");-1===n.promises.indexOf(e)&&(n.promises.push(e),n.callThen(e,function(){e.$cgBusyFulfilled=!0,-1!==n.promises.indexOf(e)&&n.promises.splice(n.promises.indexOf(e),1)},function(){e.$cgBusyFulfilled=!0,-1!==n.promises.indexOf(e)&&n.promises.splice(n.promises.indexOf(e),1)}))};return n.active=function(){return!n.delayPromise&&(n.delayJustFinished?(n.delayJustFinished=!1,0===n.promises.length&&(n.durationPromise=null),n.promises.length>0):!!n.durationPromise||n.promises.length>0)},n}}]),angular.module("cgBusy").value("cgBusyDefaults",{}),angular.module("cgBusy").directive("cgBusy",["$compile","$templateCache","cgBusyDefaults","$http","_cgBusyTrackerFactory",function(e,t,n,r,o){return{restrict:"A",link:function(i,a,s){var l=a.css("position");("static"===l||""===l||"undefined"==typeof l)&&a.css("position","relative");var u,c,d,f,p,h=o(),g={templateUrl:"angular-busy.html",delay:0,minDuration:0,backdrop:!0,message:"Please Wait...",wrapperClass:"cg-busy cg-busy-animation"};angular.extend(g,n),i.$watchCollection(s.cgBusy,function(n){if(n||(n={promise:null}),angular.isString(n))throw new Error("Invalid value for cg-busy. cgBusy no longer accepts string ids to represent promises/trackers.");(angular.isArray(n)||h.isPromise(n))&&(n={promise:n}),n=angular.extend(angular.copy(g),n),n.templateUrl||(n.templateUrl=g.templateUrl),angular.isArray(n.promise)||(n.promise=[n.promise]),f||(f=i.$new()),f.$message=n.message,angular.equals(h.promises,n.promise)||h.reset({promises:n.promise,delay:n.delay,minDuration:n.minDuration}),f.$cgBusyIsActive=function(){return h.active()},u&&d===n.templateUrl&&p===n.backdrop||(u&&u.remove(),c&&c.remove(),d=n.templateUrl,p=n.backdrop,r.get(d,{cache:t}).then(function(t){if(n.backdrop="undefined"==typeof n.backdrop||n.backdrop,n.backdrop){var r='<div class="cg-busy cg-busy-backdrop cg-busy-backdrop-animation ng-hide" ng-show="$cgBusyIsActive()"></div>';c=e(r)(f),a.append(c)}var o='<div class="'+n.wrapperClass+' ng-hide" ng-show="$cgBusyIsActive()">'+t.data+"</div>";u=e(o)(f),angular.element(u.children()[0]).css("position","absolute").css("top",0).css("left",0).css("right",0).css("bottom",0),a.append(u)},function(e){throw new Error("Template specified for cgBusy ("+n.templateUrl+") could not be loaded. "+e)}))},!0)}}}]),angular.module("cgBusy").run(["$templateCache",function(e){"use strict";e.put("angular-busy.html",'<div class="cg-busy-default-wrapper">\n\n   <div class="cg-busy-default-sign">\n\n      <div class="cg-busy-default-spinner">\n         <div class="bar1"></div>\n         <div class="bar2"></div>\n         <div class="bar3"></div>\n         <div class="bar4"></div>\n         <div class="bar5"></div>\n         <div class="bar6"></div>\n         <div class="bar7"></div>\n         <div class="bar8"></div>\n         <div class="bar9"></div>\n         <div class="bar10"></div>\n         <div class="bar11"></div>\n         <div class="bar12"></div>\n      </div>\n\n      <div class="cg-busy-default-text">{{$message}}</div>\n\n   </div>\n\n</div>')}]),angular.module("angularPromiseButtons",[]),angular.module("angularPromiseButtons").directive("promiseBtn",["angularPromiseButtons","$parse","$timeout","$compile",function(e,t,n,r){"use strict";return{restrict:"EA",priority:e.config.priority,scope:{promiseBtn:"=",promiseBtnOptions:"=?"},link:function(o,i,a){function s(e){b.btnLoadingClass&&!b.addClassToCurrentBtnOnly&&e.addClass(b.btnLoadingClass),b.disableBtn&&!b.disableCurrentBtnOnly&&e.attr("disabled","disabled")}function l(e){b.minDuration&&!v||!y||(b.btnLoadingClass&&e.removeClass(b.btnLoadingClass),b.disableBtn&&e.removeAttr("disabled"))}function u(e,t){o.$watch(e,function(e){v=!1,y=!1,b.minDuration&&(m=n(function(){v=!0,l(t)},b.minDuration)),e&&e.then?(s(t),e.finally(function(){y=!0,l(t)})):e&&e.$promise&&(s(t),e.$promise.finally(function(){y=!0,l(t)}))})}function c(e){return e.split(";").map(function(e){return t(e)})}function d(e){e.append(r(b.spinnerTpl)(o))}function f(e){b.addClassToCurrentBtnOnly&&e.on(b.CLICK_EVENT,function(){e.addClass(b.btnLoadingClass)}),b.disableCurrentBtnOnly&&e.on(b.CLICK_EVENT,function(){e.attr("disabled","disabled")})}function p(e,t,n){o.$evalAsync(function(){var r=c(a[t]);i.unbind(e),i.bind(e,function(){o.$apply(function(){r.forEach(function(t){var r=t(o.$parent,{$event:e});g||(g=u(function(){return r},n))})})})})}function h(t){for(var n=[],r=t.find(e.config.BTN_SELECTOR),o=0;o<r.length;o++){var i=r[o];"submit"===angular.element(i).attr("type")&&n.push(i)}return angular.element(n)}var g,m,v,y,b=e.config;if(a.promiseBtn)d(i),f(i),u(function(){return o.promiseBtn},i);else if(a.hasOwnProperty(b.CLICK_ATTR))d(i),f(i),p(b.CLICK_EVENT,b.CLICK_ATTR,i);else if(a.hasOwnProperty(b.SUBMIT_ATTR)){var C=h(i);d(C),f(C),p(b.SUBMIT_EVENT,b.SUBMIT_ATTR,C)}o.$watch("promiseBtnOptions",function(e){angular.isObject(e)&&(b=angular.extend({},b,e))},!0),o.$on("$destroy",function(){n.cancel(m)})}}}]),angular.module("angularPromiseButtons").provider("angularPromiseButtons",function(){"use strict";var e={spinnerTpl:'<span class="btn-spinner"></span>',priority:0,disableBtn:!0,btnLoadingClass:"is-loading",addClassToCurrentBtnOnly:!1,disableCurrentBtnOnly:!1,minDuration:!1,CLICK_EVENT:"click",CLICK_ATTR:"ngClick",SUBMIT_EVENT:"submit",SUBMIT_ATTR:"ngSubmit",BTN_SELECTOR:"button"};return{extendConfig:function(t){e=angular.extend(e,t)},$get:function(){return{config:e}}}}),!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var t;t="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,t.angularDragula=e()}}(function(){return function e(t,n,r){function o(a,s){if(!n[a]){if(!t[a]){var l="function"==typeof require&&require;if(!s&&l)return l(a,!0);if(i)return i(a,!0);var u=new Error("Cannot find module '"+a+"'");throw u.code="MODULE_NOT_FOUND",u}var c=n[a]={exports:{}};t[a][0].call(c.exports,function(e){var n=t[a][1][e];return o(n?n:e)},c,c.exports,e,t,n,r)}return n[a].exports}for(var i="function"==typeof require&&require,a=0;a<r.length;a++)o(r[a]);return o}({1:[function(e,t,n){"use strict";function r(e){var t=e.module("dragula",["ng"]);return t.factory("dragulaService",o(e)),t.directive("dragula",i(e)),"dragula"}var o=e("./service"),i=e("./directive");t.exports=r},{"./directive":2,"./service":13}],2:[function(e,t,n){"use strict";function r(e){return["dragulaService",function(e){function t(t,n,r){var i,a=t.dragulaScope||t.$parent,s=n[0],l=t.$eval(r.dragula),u=e.find(a,l);u?(i=u.drake,i.containers.push(s)):(i=o({containers:[s]}),e.add(a,l,i)),t.$watch("dragulaModel",function(t,n){if(t){if(i.models){var r=n?i.models.indexOf(n):-1;r>=0?i.models.splice(r,1,t):i.models.push(t)}else i.models=[t];e.handleModels(a,i)}})}return{restrict:"A",scope:{dragulaScope:"=",dragulaModel:"="},link:t}}]}var o=e("dragula");t.exports=r},{dragula:10}],3:[function(e,t,n){t.exports=function(e,t){return Array.prototype.slice.call(e,t)}},{}],4:[function(e,t,n){"use strict";var r=e("ticky");t.exports=function(e,t,n){e&&r(function(){e.apply(n||null,t||[])})}},{ticky:11}],5:[function(e,t,n){"use strict";var r=e("atoa"),o=e("./debounce");t.exports=function(e,t){var n=t||{},i={};return void 0===e&&(e={}),e.on=function(t,n){return i[t]?i[t].push(n):i[t]=[n],e},e.once=function(t,n){return n._once=!0,e.on(t,n),e},e.off=function(t,n){var r=arguments.length;if(1===r)delete i[t];else if(0===r)i={};else{var o=i[t];if(!o)return e;o.splice(o.indexOf(n),1)}return e},e.emit=function(){var t=r(arguments);return e.emitterSnapshot(t.shift()).apply(this,t)},e.emitterSnapshot=function(t){var a=(i[t]||[]).slice(0);return function(){var i=r(arguments),s=this||e;if("error"===t&&n.throws!==!1&&!a.length)throw 1===i.length?i[0]:i;return a.forEach(function(r){n.async?o(r,i,s):r.apply(s,i),r._once&&e.off(t,r)}),e}},e}},{"./debounce":4,atoa:3}],6:[function(e,t,n){(function(n){"use strict";function r(e,t,n,r){return e.addEventListener(t,n,r)}function o(e,t,n){return e.attachEvent("on"+t,u(e,t,n))}function i(e,t,n,r){return e.removeEventListener(t,n,r)}function a(e,t,n){var r=c(e,t,n);return r?e.detachEvent("on"+t,r):void 0}function s(e,t,n){function r(){var e;return h.createEvent?(e=h.createEvent("Event"),e.initEvent(t,!0,!0)):h.createEventObject&&(e=h.createEventObject()),e}function o(){return new f(t,{detail:n})}var i=-1===p.indexOf(t)?o():r();e.dispatchEvent?e.dispatchEvent(i):e.fireEvent("on"+t,i)}function l(e,t,r){return function(t){var o=t||n.event;o.target=o.target||o.srcElement,o.preventDefault=o.preventDefault||function(){o.returnValue=!1},o.stopPropagation=o.stopPropagation||function(){o.cancelBubble=!0},o.which=o.which||o.keyCode,r.call(e,o)}}function u(e,t,n){var r=c(e,t,n)||l(e,t,n);return v.push({wrapper:r,element:e,type:t,fn:n}),r}function c(e,t,n){var r=d(e,t,n);if(r){var o=v[r].wrapper;return v.splice(r,1),o}}function d(e,t,n){var r,o;for(r=0;r<v.length;r++)if(o=v[r],o.element===e&&o.type===t&&o.fn===n)return r}var f=e("custom-event"),p=e("./eventmap"),h=n.document,g=r,m=i,v=[];n.addEventListener||(g=o,m=a),t.exports={add:g,remove:m,fabricate:s}}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"./eventmap":7,"custom-event":8}],7:[function(e,t,n){(function(e){"use strict";var n=[],r="",o=/^on/;for(r in e)o.test(r)&&n.push(r.slice(2));t.exports=n}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{}],8:[function(e,t,n){(function(e){function n(){try{var e=new r("cat",{detail:{foo:"bar"}});return"cat"===e.type&&"bar"===e.detail.foo}catch(e){}return!1}var r=e.CustomEvent;t.exports=n()?r:"function"==typeof document.createEvent?function(e,t){var n=document.createEvent("CustomEvent");return t?n.initCustomEvent(e,t.bubbles,t.cancelable,t.detail):n.initCustomEvent(e,!1,!1,void 0),n}:function(e,t){var n=document.createEventObject();return n.type=e,t?(n.bubbles=Boolean(t.bubbles),n.cancelable=Boolean(t.cancelable),n.detail=t.detail):(n.bubbles=!1,n.cancelable=!1,n.detail=void 0),n}}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{}],9:[function(e,t,n){"use strict";function r(e){var t=a[e];return t?t.lastIndex=0:a[e]=t=new RegExp(s+e+l,"g"),t}function o(e,t){var n=e.className;n.length?r(t).test(n)||(e.className+=" "+t):e.className=t}function i(e,t){e.className=e.className.replace(r(t)," ").trim()}var a={},s="(?:^|\\s)",l="(?:\\s|$)";t.exports={add:o,rm:i}},{}],10:[function(e,t,n){(function(n){"use strict";function r(e,t){function n(e){return-1!==ce.containers.indexOf(e)||ue.isContainer(e)}function r(e){var t=e?"remove":"add";o($,t,"mousedown",x),o($,t,"mouseup",N)}function s(e){var t=e?"remove":"add";o($,t,"mousemove",E)}function g(e){var t=e?"remove":"add";C[t]($,"selectstart",T),C[t]($,"click",T)}function v(){r(!0),N({})}function T(e){se&&e.preventDefault()}function x(e){te=e.clientX,ne=e.clientY;var t=1!==i(e)||e.metaKey||e.ctrlKey;if(!t){var n=e.target,r=k(n);r&&(se=r,s(),"mousedown"===e.type&&(h(n)?n.focus():e.preventDefault()))}}function E(e){if(se){if(0===i(e))return void N({});if(void 0===e.clientX||e.clientX!==te||void 0===e.clientY||e.clientY!==ne){if(ue.ignoreInputTextSelection){var t=y("clientX",e),n=y("clientY",e),r=S.elementFromPoint(t,n);if(h(r))return}var o=se;s(!0),g(),M(),B(o);var l=a(Z);J=y("pageX",e)-l.left,ee=y("pageY",e)-l.top,w.add(ie||Z,"gu-transit"),W(),z(e)}}}function k(e){if(!(ce.dragging&&Y||n(e))){for(var t=e;p(e)&&n(p(e))===!1;){if(ue.invalid(e,t))return;if(e=p(e),!e)return}var r=p(e);if(r&&!ue.invalid(e,t)){var o=ue.moves(e,r,t,m(e));if(o)return{item:e,source:r}}}}function A(e){return!!k(e)}function O(e){var t=k(e);t&&B(t)}function B(e){G(e.item,e.source)&&(ie=e.item.cloneNode(!0),ce.emit("cloned",ie,e.item,"copy")),Q=e.source,Z=e.item,re=oe=m(e.item),ce.dragging=!0,ce.emit("drag",Z,Q)}function L(){return!1}function M(){if(ce.dragging){var e=ie||Z;D(e,p(e))}}function P(){se=!1,s(!0),g(!0)}function N(e){if(P(),ce.dragging){var t=ie||Z,n=y("clientX",e),r=y("clientY",e),o=l(Y,n,r),i=R(o,n,r);i&&(ie&&ue.copySortSource||!ie||i!==Q)?D(t,i):ue.removeOnSpill?I():_()}}function D(e,t){var n=p(e);ie&&ue.copySortSource&&t===Q&&n.removeChild(Z),j(t)?ce.emit("cancel",e,Q,Q):ce.emit("drop",e,t,Q,oe),F()}function I(){if(ce.dragging){var e=ie||Z,t=p(e);t&&t.removeChild(e),ce.emit(ie?"cancel":"remove",e,t,Q),F()}}function _(e){if(ce.dragging){var t=arguments.length>0?e:ue.revertOnSpill,n=ie||Z,r=p(n),o=j(r);o===!1&&t&&(ie?r&&r.removeChild(ie):Q.insertBefore(n,re)),o||t?ce.emit("cancel",n,Q,Q):ce.emit("drop",n,r,Q,oe),F()}}function F(){var e=ie||Z;P(),H(),e&&w.rm(e,"gu-transit"),ae&&clearTimeout(ae),ce.dragging=!1,le&&ce.emit("out",e,le,Q),ce.emit("dragend",e),Q=Z=ie=re=oe=ae=le=null}function j(e,t){var n;return n=void 0!==t?t:Y?oe:m(ie||Z),e===Q&&n===re}function R(e,t,r){function o(){var o=n(i);if(o===!1)return!1;var a=V(i,e),s=X(i,a,t,r),l=j(i,s);return!!l||ue.accepts(Z,i,Q,s)}for(var i=e;i&&!o();)i=p(i);return i}function z(e){function t(e){ce.emit(e,u,le,Q)}function n(){f&&t("over")}function r(){le&&t("out")}if(Y){e.preventDefault();var o=y("clientX",e),i=y("clientY",e),a=o-J,s=i-ee;Y.style.left=a+"px",Y.style.top=s+"px";var u=ie||Z,c=l(Y,o,i),d=R(c,o,i),f=null!==d&&d!==le;(f||null===d)&&(r(),le=d,n());var h=p(u);if(d===Q&&ie&&!ue.copySortSource)return void(h&&h.removeChild(u));var g,v=V(d,c);if(null!==v)g=X(d,v,o,i);else{if(ue.revertOnSpill!==!0||ie)return void(ie&&h&&h.removeChild(u));g=re,d=Q}(null===g&&f||g!==u&&g!==m(u))&&(oe=g,d.insertBefore(u,g),ce.emit("shadow",u,d,Q))}}function U(e){w.rm(e,"gu-hide")}function q(e){ce.dragging&&w.add(e,"gu-hide")}function W(){if(!Y){var e=Z.getBoundingClientRect();Y=Z.cloneNode(!0),Y.style.width=d(e)+"px",Y.style.height=f(e)+"px",w.rm(Y,"gu-transit"),w.add(Y,"gu-mirror"),ue.mirrorContainer.appendChild(Y),o($,"add","mousemove",z),w.add(ue.mirrorContainer,"gu-unselectable"),ce.emit("cloned",Y,Z,"mirror")}}function H(){Y&&(w.rm(ue.mirrorContainer,"gu-unselectable"),o($,"remove","mousemove",z),p(Y).removeChild(Y),Y=null)}function V(e,t){for(var n=t;n!==e&&p(n)!==e;)n=p(n);return n===$?null:n}function X(e,t,n,r){function o(){var t,o,i,a=e.children.length;for(t=0;a>t;t++){if(o=e.children[t],i=o.getBoundingClientRect(),s&&i.left+i.width/2>n)return o;if(!s&&i.top+i.height/2>r)return o}return null}function i(){var e=t.getBoundingClientRect();return a(s?n>e.left+d(e)/2:r>e.top+f(e)/2)}function a(e){return e?m(t):t}var s="horizontal"===ue.direction,l=t!==e?i():o();return l}function G(e,t){return"boolean"==typeof ue.copy?ue.copy:ue.copy(e,t)}var K=arguments.length;1===K&&Array.isArray(e)===!1&&(t=e,e=[]);var Y,Q,Z,J,ee,te,ne,re,oe,ie,ae,se,le=null,ue=t||{};void 0===ue.moves&&(ue.moves=c),void 0===ue.accepts&&(ue.accepts=c),void 0===ue.invalid&&(ue.invalid=L),void 0===ue.containers&&(ue.containers=e||[]),void 0===ue.isContainer&&(ue.isContainer=u),void 0===ue.copy&&(ue.copy=!1),void 0===ue.copySortSource&&(ue.copySortSource=!1),void 0===ue.revertOnSpill&&(ue.revertOnSpill=!1),void 0===ue.removeOnSpill&&(ue.removeOnSpill=!1),void 0===ue.direction&&(ue.direction="vertical"),void 0===ue.ignoreInputTextSelection&&(ue.ignoreInputTextSelection=!0),void 0===ue.mirrorContainer&&(ue.mirrorContainer=S.body);var ce=b({containers:ue.containers,start:O,end:M,cancel:_,remove:I,destroy:v,canMove:A,dragging:!1});return ue.removeOnSpill===!0&&ce.on("over",U).on("out",q),r(),ce}function o(e,t,r,o){var i={mouseup:"touchend",mousedown:"touchstart",mousemove:"touchmove"},a={mouseup:"pointerup",mousedown:"pointerdown",mousemove:"pointermove"},s={mouseup:"MSPointerUp",mousedown:"MSPointerDown",mousemove:"MSPointerMove"};n.navigator.pointerEnabled?C[t](e,a[r],o):n.navigator.msPointerEnabled?C[t](e,s[r],o):(C[t](e,i[r],o),C[t](e,r,o))}function i(e){if(void 0!==e.touches)return e.touches.length;if(void 0!==e.which&&0!==e.which)return e.which;if(void 0!==e.buttons)return e.buttons;var t=e.button;return void 0!==t?1&t?1:2&t?3:4&t?2:0:void 0}function a(e){var t=e.getBoundingClientRect();return{left:t.left+s("scrollLeft","pageXOffset"),top:t.top+s("scrollTop","pageYOffset")}}function s(e,t){return"undefined"!=typeof n[t]?n[t]:$.clientHeight?$[e]:S.body[e]}function l(e,t,n){var r,o=e||{},i=o.className;return o.className+=" gu-hide",r=S.elementFromPoint(t,n),o.className=i,r}function u(){return!1}function c(){return!0}function d(e){return e.width||e.right-e.left}function f(e){return e.height||e.bottom-e.top}function p(e){return e.parentNode===S?null:e.parentNode}function h(e){return"INPUT"===e.tagName||"TEXTAREA"===e.tagName||"SELECT"===e.tagName||g(e)}function g(e){return!!e&&("false"!==e.contentEditable&&("true"===e.contentEditable||g(p(e))))}function m(e){function t(){var t=e;do t=t.nextSibling;while(t&&1!==t.nodeType);return t}return e.nextElementSibling||t()}function v(e){return e.targetTouches&&e.targetTouches.length?e.targetTouches[0]:e.changedTouches&&e.changedTouches.length?e.changedTouches[0]:e}function y(e,t){var n=v(t),r={pageX:"clientX",pageY:"clientY"};return e in r&&!(e in n)&&r[e]in n&&(e=r[e]),n[e]}var b=e("contra/emitter"),C=e("crossvent"),w=e("./classes"),S=document,$=S.documentElement;t.exports=r}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"./classes":9,"contra/emitter":5,crossvent:6}],11:[function(e,t,n){var r,o="function"==typeof setImmediate;r=o?function(e){setImmediate(e)}:function(e){setTimeout(e,0)},t.exports=r},{}],12:[function(e,t,n){"use strict";function r(e,t,n){function r(e){function r(){var r=o(arguments).map(a);r.unshift(t.name+"."+e),n.$emit.apply(n,r)}t.drake.on(e,r)}function a(t){return e.isElement(t)?e.element(t):t}i.forEach(r)}var o=e("atoa"),i=["cancel","cloned","drag","dragend","drop","out","over","remove","shadow","drop-model","remove-model"];t.exports=r},{atoa:3}],13:[function(e,t,n){"use strict";function r(e){return[function(){function t(t,n){if(!n.registered){var o,i,a,s;n.on("remove",function(e,r){n.models&&(s=n.models[n.containers.indexOf(r)],t.$applyAsync(function(){s.splice(i,1),n.emit("remove-model",e,r)}))}),n.on("drag",function(e,t){o=e,i=r(e,t)}),n.on("drop",function(l,u,c){n.models&&(a=r(l,u),t.$applyAsync(function(){if(s=n.models[n.containers.indexOf(c)],u===c)s.splice(a,0,s.splice(i,1)[0]);else{var t=o===l,r=n.models[n.containers.indexOf(u)],d=t?s[i]:e.copy(s[i]);t&&s.splice(i,1),r.splice(a,0,d),u.removeChild(l)}n.emit("drop-model",l,u,c)}))}),n.registered=!0}}function n(e){var t=e[i];return t||(t=e[i]={bags:[]}),t}function r(t,n){return Array.prototype.indexOf.call(e.element(n).children(),t);
}function s(r,o,i){var s=l(r,o);if(s)throw new Error('Bag named: "'+o+'" already exists in same angular scope.');var u=n(r);return s={name:o,drake:i},u.bags.push(s),a(e,s,r),i.models&&t(r,i),s}function l(e,t){for(var r=n(e).bags,o=0;o<r.length;o++)if(r[o].name===t)return r[o]}function u(e,t){var r=n(e).bags,o=l(e,t),i=r.indexOf(o);r.splice(i,1),o.drake.destroy()}function c(e,n,r){var i=s(e,n,o(r));t(e,i.drake)}return{add:s,find:l,options:c,destroy:u,handleModels:t}}]}var o=e("dragula"),i="$$dragula",a=e("./replicate-events");t.exports=r},{"./replicate-events":12,dragula:10}]},{},[1])(1)}),angular.module("oitozero.ngSweetAlert",[]).factory("SweetAlert",["$rootScope",function(e){var t=window.swal,n={swal:function(n,r,o){e.$evalAsync(function(){"function"==typeof r?t(n,function(t){e.$evalAsync(function(){r(t)})},o):t(n,r,o)})},success:function(n,r){e.$evalAsync(function(){t(n,r,"success")})},error:function(n,r){e.$evalAsync(function(){t(n,r,"error")})},warning:function(n,r){e.$evalAsync(function(){t(n,r,"warning")})},info:function(n,r){e.$evalAsync(function(){t(n,r,"info")})},showInputError:function(n){e.$evalAsync(function(){t.showInputError(n)})},close:function(){e.$evalAsync(function(){t.close()})}};return n}]);